# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_denm_ts_msgs/ImpactReductionContainer.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_denm_ts_msgs.msg

class ImpactReductionContainer(genpy.Message):
  _md5sum = "b161458cf05add72b83698a3eb24ae64"
  _type = "etsi_its_denm_ts_msgs/ImpactReductionContainer"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This type contains detailed information about the vehicle in which the originating ITS-S is mounted, for mitigating the consequences 
#  * of a collision.
#  *
#  * It shall include the following components: 
#  *
#  * @field heightLonCarrLeft: the height of the left longitudinal carrier of the vehicle from base to top.
#  *
#  * @field heightLonCarrRight: the height of the right longitudinal carrier of the vehicle from base to top.
#  *
#  * @field posLonCarrLeft: the position of the left longitudinal carrier of vehicle.
#  *
#  * @field posLonCarrRight: the position of the right longitudinal carrier of vehicle.
#  *
#  * @field positionOfPillars: information about the vertical support of the vehicle in which the originating ITS-S is mounted. It shall be 
#  * included for passenger vehicles only.
#  *
#  * @field posCentMass: the position of the centre of mass of the vehicle.
#  *
#  * @field wheelBaseVehicle: the wheel base of the vehicle.
#  *
#  * @field turningRadius: the turning radius of the vehicle.
#  *
#  * @field posFrontAx: the position of the front axle of the vehicle.
#  *
#  * @field positionOfOccupants: indicates whether an in-vehicle seat is occupied at the moment of generation of the message.
#  *
#  * @field vehicleMass: the mass of the unloaded vehicle
#  *
#  * @field requestResponseIndication: indicates whether the originating ITS-S transmitting the impactReduction component is requesting 
#  * the receiving ITS-S to provide also its impactReduction component.
#  *
# */
# ImpactReductionContainer ::= SEQUENCE {
#     heightLonCarrLeft         HeightLonCarr,
#     heightLonCarrRight        HeightLonCarr,
#     posLonCarrLeft            PosLonCarr,
#     posLonCarrRight           PosLonCarr,
#     positionOfPillars         PositionOfPillars,
#     posCentMass               PosCentMass,
#     wheelBaseVehicle          WheelBaseVehicle,
#     turningRadius             TurningRadius,
#     posFrontAx                PosFrontAx,
#     positionOfOccupants       PositionOfOccupants,
#     vehicleMass               VehicleMass,
#     requestResponseIndication RequestResponseIndication
# }
# ------------------------------------------------------------------------------

HeightLonCarr height_lon_carr_left

HeightLonCarr height_lon_carr_right

PosLonCarr pos_lon_carr_left

PosLonCarr pos_lon_carr_right

PositionOfPillars position_of_pillars

PosCentMass pos_cent_mass

WheelBaseVehicle wheel_base_vehicle

TurningRadius turning_radius

PosFrontAx pos_front_ax

PositionOfOccupants position_of_occupants

VehicleMass vehicle_mass

RequestResponseIndication request_response_indication


================================================================================
MSG: etsi_its_denm_ts_msgs/HeightLonCarr
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the height of the left or right longitude carrier of vehicle from base to top (left or right carrier seen from vehicle
#  * rear to front). 
#  *
#  * The value shall be set to:
#  * - `n` (`n >= 1` and `n < 99`) if the height information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
#  * - `99` if the height is out of range, i.e. equal to or greater than 0,98 m,
#  * - `100` if the height information is not available.
#  *
#  * @unit 0,01 metre
#  * @category Vehicle information
#  * @revision: Description revised in V2.1.1 (the definition of 99 has changed slightly) 
#  */
# HeightLonCarr ::= INTEGER {
#     outOfRange(99),
#     unavailable(100)
# } (1..100)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 100
uint8 OUT_OF_RANGE = 99
uint8 UNAVAILABLE = 100


================================================================================
MSG: etsi_its_denm_ts_msgs/PosLonCarr
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the distance from the centre of vehicle front bumper to the right or left longitudinal carrier of vehicle.
#  * The left/right carrier refers to the left/right as seen from a passenger sitting in the vehicle.
#  *
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 126`) for any aplicable value between 0,01 metre and 1,26 metres, 
#  * - `126` for values equal to or higher than 1.25 metres,
#  * - `127` if the information is unavailable.
#  *
#  * @unit 0,01 metre 
#  * @category Vehicle information
#  * @revision: description revised in V2.1.1 (the meaning of 126 has changed slightly) 
#  */
# PosLonCarr ::= INTEGER {
#     outOfRange  (126),
#     unavailable (127)
# } (1..127)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 127
uint8 OUT_OF_RANGE = 126
uint8 UNAVAILABLE = 127


================================================================================
MSG: etsi_its_denm_ts_msgs/PositionOfPillars
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF shall contain a list of distances @ref PosPillar that refer to the perpendicular distance between centre of vehicle front bumper
#  * and vehicle pillar A, between neighbour pillars until the last pillar of the vehicle.
#  *
#  * Vehicle pillars refer to the vertical or near vertical support of vehicle,
#  * designated respectively as the A, B, C or D and other pillars moving in side profile view from the front to rear.
#  * 
#  * The first value of the DF refers to the perpendicular distance from the centre of vehicle front bumper to 
#  * vehicle A pillar. The second value refers to the perpendicular distance from the centre position of A pillar
#  * to the B pillar of vehicle and so on until the last pillar.
#  *
#  * @category: Vehicle information
#  * @revision: V1.3.1
#  */
# PositionOfPillars ::= SEQUENCE (SIZE(1..3, ...)) OF PosPillar
# ------------------------------------------------------------------------------

PosPillar[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 3


================================================================================
MSG: etsi_its_denm_ts_msgs/PosPillar
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the perpendicular inter-distance of neighbouring pillar axis of vehicle starting from the
#  * middle point of the front line of the vehicle bounding box.
#  *
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 29`) for any aplicable value between 0,1 metre and 2,9 metres, 
#  * - `29` for values equal to or greater than 2.8 metres,
#  * - `30` if the information is unavailable.
#  * 
#  * @unit 0,1 metre 
#  * @category Vehicle information
#  * @revision: description revised in V2.1.1 (the meaning of 29 has changed slightly) 
#  */
# PosPillar ::= INTEGER {
#     outOfRange  (29),
#     unavailable (30)
# } (1..30)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 30
uint8 OUT_OF_RANGE = 29
uint8 UNAVAILABLE = 30


================================================================================
MSG: etsi_its_denm_ts_msgs/PosCentMass
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the perpendicular distance from the centre of mass of an empty load vehicle to the front line of
#  * the vehicle bounding box of the empty load vehicle.
#  *
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 62`) for any aplicable value n between 0,1 metre and 6,2 metres, 
#  * - `62` for values equal to or higher than 6.1 metres,
#  * - `63`  if the information is unavailable.
#  * 
#  * @note:	The empty load vehicle is defined in ISO 1176 [8], clause 4.6.
#  *
#  * @unit 0,1 metre 
#  * @category Vehicle information
#  * @revision: description revised in V2.1.1 (the meaning of 62 has changed slightly) 
#  */
# PosCentMass ::= INTEGER {
#     tenCentimetres (1), 
#     outOfRange     (62),
#     unavailable    (63)
# } (1..63)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 63
uint8 TEN_CENTIMETRES = 1
uint8 OUT_OF_RANGE = 62
uint8 UNAVAILABLE = 63


================================================================================
MSG: etsi_its_denm_ts_msgs/WheelBaseVehicle
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the perpendicular distance between front and rear axle of the wheel base of vehicle.
#  *
#  * The value shall be set to:
#  * - `n` (`n >= 1` and `n < 126`) if the value is equal to or less than n x 0,1 metre  and more than (n-1) x 0,1 metre,
#  * - `126` indicates that the wheel base distance is equal to or greater than 12,5 metres,
#  * - `127` indicates that the information is unavailable.
#  *
#  * @unit 0,1 metre
#  * @category: Vehicle information
#  * @revision: Created in V2.1.1
#  */
# WheelBaseVehicle ::= INTEGER {
#     outOfRange  (126),
#     unavailable (127)
# } (1..127)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 127
uint8 OUT_OF_RANGE = 126
uint8 UNAVAILABLE = 127


================================================================================
MSG: etsi_its_denm_ts_msgs/TurningRadius
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the smallest circular turn (i.e. U-turn) that the vehicle is capable of making.
#  *
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 254`) to indicate the applicable value is equal to or less than n x 0,4 metre, and greater than (n-1) x 0,4 metre,
#  * - `254` to indicate that the turning radius is  greater than 253 x 0,4 metre = 101.2 metres,
#  * - `255` to indicate that the information is unavailable.
#  * 
#  * For vehicle with tracker, the turning radius applies to the vehicle only.
#  *
#  * @category: Vehicle information
#  * @unit 0,4 metre
#  * @revision: Description revised V2.1.1 (the meaning of 254 has changed slightly)
#  */
# TurningRadius ::= INTEGER {
#     outOfRange  (254),
#     unavailable (255)
# } (1..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 255
uint8 OUT_OF_RANGE = 254
uint8 UNAVAILABLE = 255


================================================================================
MSG: etsi_its_denm_ts_msgs/PosFrontAx
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the perpendicular distance between the vehicle front line of the bounding box and the front wheel axle in 0,1 metre.
#  *
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 19`) for any aplicable value between 0,1 metre and 1,9 metres,
#  * - `19` for values equal to or higher than 1.8 metres,
#  * - `20` if the information is unavailable.
#  *
#  * @category: Vehicle information
#  * @unit 0,1 metre
#  * @revision: description revised in V2.1.1 (the meaning of 19 has changed slightly) 
#  */
# PosFrontAx ::= INTEGER {
#     outOfRange (19), 
#     unavailable(20)
# } (1..20)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 20
uint8 OUT_OF_RANGE = 19
uint8 UNAVAILABLE = 20


================================================================================
MSG: etsi_its_denm_ts_msgs/PositionOfOccupants
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates whether a passenger seat is occupied or whether the occupation status is detectable or not.
#  * 
#  * The number of row in vehicle seats layout is counted in rows from the driver row backwards from front to the rear
#  * of the vehicle.
#  * The left side seat of a row refers to the left hand side seen from vehicle rear to front.
#  * Additionally, a bit is reserved for each seat row, to indicate if the seat occupation of a row is detectable or not,
#  * i.e. `row1NotDetectable (3)`, `row2NotDetectable(8)`, `row3NotDetectable(13)` and `row4NotDetectable(18)`.
#  * Finally, a bit is reserved for each row seat to indicate if the seat row is present or not in the vehicle,
#  * i.e. `row1NotPresent (4)`, `row2NotPresent (9)`, `row3NotPresent(14)`, `row4NotPresent(19)`.
#  * 
#  * When a seat is detected to be occupied, the corresponding seat occupation bit shall be set to `1`.
#  * For example, when the row 1 left seat is occupied, `row1LeftOccupied(0)` bit shall be set to `1`.
#  * When a seat is detected to be not occupied, the corresponding seat occupation bit shall be set to `0`.
#  * Otherwise, the value of seat occupation bit shall be set according to the following conditions:
#  * - If the seat occupation of a seat row is not detectable, the corresponding bit shall be set to `1`.
#  *   When any seat row not detectable bit is set to `1`, all corresponding seat occupation bits of the same row
#  *   shall be set to `1`.
#  * - If the seat row is not present, the corresponding not present bit of the same row shall be set to `1`.
#  *   When any of the seat row not present bit is set to `1`, the corresponding not detectable bit for that row
#  *   shall be set to `1`, and all the corresponding seat occupation bits in that row shall be set to `0`.
#  * 
#  * @category: Vehicle information
#  * @revision: V1.3.1
#  */
# PositionOfOccupants ::= BIT STRING {
#     row1LeftOccupied  (0),
#     row1RightOccupied (1),
#     row1MidOccupied   (2),
#     row1NotDetectable (3),
#     row1NotPresent    (4),
#     row2LeftOccupied  (5),
#     row2RightOccupied (6),
#     row2MidOccupied   (7),
#     row2NotDetectable (8),
#     row2NotPresent    (9),
#     row3LeftOccupied  (10),
#     row3RightOccupied (11),
#     row3MidOccupied   (12),
#     row3NotDetectable (13),
#     row3NotPresent    (14),
#     row4LeftOccupied  (15),
#     row4RightOccupied (16),
#     row4MidOccupied   (17),
#     row4NotDetectable (18),
#     row4NotPresent    (19)
# } (SIZE(20))
# ------------------------------------------------------------------------------

uint8[] value
uint8 bits_unused
uint8 SIZE_BITS = 20
uint8 BIT_INDEX_ROW1_LEFT_OCCUPIED = 0
uint8 BIT_INDEX_ROW1_RIGHT_OCCUPIED = 1
uint8 BIT_INDEX_ROW1_MID_OCCUPIED = 2
uint8 BIT_INDEX_ROW1_NOT_DETECTABLE = 3
uint8 BIT_INDEX_ROW1_NOT_PRESENT = 4
uint8 BIT_INDEX_ROW2_LEFT_OCCUPIED = 5
uint8 BIT_INDEX_ROW2_RIGHT_OCCUPIED = 6
uint8 BIT_INDEX_ROW2_MID_OCCUPIED = 7
uint8 BIT_INDEX_ROW2_NOT_DETECTABLE = 8
uint8 BIT_INDEX_ROW2_NOT_PRESENT = 9
uint8 BIT_INDEX_ROW3_LEFT_OCCUPIED = 10
uint8 BIT_INDEX_ROW3_RIGHT_OCCUPIED = 11
uint8 BIT_INDEX_ROW3_MID_OCCUPIED = 12
uint8 BIT_INDEX_ROW3_NOT_DETECTABLE = 13
uint8 BIT_INDEX_ROW3_NOT_PRESENT = 14
uint8 BIT_INDEX_ROW4_LEFT_OCCUPIED = 15
uint8 BIT_INDEX_ROW4_RIGHT_OCCUPIED = 16
uint8 BIT_INDEX_ROW4_MID_OCCUPIED = 17
uint8 BIT_INDEX_ROW4_NOT_DETECTABLE = 18
uint8 BIT_INDEX_ROW4_NOT_PRESENT = 19


================================================================================
MSG: etsi_its_denm_ts_msgs/VehicleMass
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the mass of an empty loaded vehicle.
#  *
#  * The value shall be set to: 
#  * - `n` (`n > 0` and `n < 1023`) to indicate that the applicable value is equal to or less than n x 10^5 gramm, and greater than (n-1) x 10^5 gramm,
#  * - `1 023` indicates that the vehicle mass is greater than 102 200 000 g,
#  * - `1 024` indicates  the vehicle mass information is unavailable.
#  * 
#  * @note:	The empty load vehicle is defined in ISO 1176 [8], clause 4.6.
#  * 
#  * @unit: 10^5 gramm
#  * @category: Vehicle information
#  * @revision: Description updated in V2.1.1 (the meaning of 1 023 has changed slightly).
# */
# VehicleMass ::= INTEGER {
#     outOfRange (1023), 
#     unavailable(1024)
# } (1..1024) 
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 1
uint16 MAX = 1024
uint16 OUT_OF_RANGE = 1023
uint16 UNAVAILABLE = 1024


================================================================================
MSG: etsi_its_denm_ts_msgs/RequestResponseIndication
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates whether an ITS message is transmitted as request from ITS-S or a response transmitted from
#  * ITS-S after receiving request from other ITS-Ss.
#  *
#  * The value shall be set to:
#  * - 0 `request`  - for a request message, 
#  * - 1 `response` - for a response message.  
#  *
#  * @category Communication information
#  * @revision: Editorial update in V2.1.1
#  */
# RequestResponseIndication ::= ENUMERATED {
#     request  (0), 
#     response (1)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 REQUEST = 0
uint8 RESPONSE = 1

"""
  __slots__ = ['height_lon_carr_left','height_lon_carr_right','pos_lon_carr_left','pos_lon_carr_right','position_of_pillars','pos_cent_mass','wheel_base_vehicle','turning_radius','pos_front_ax','position_of_occupants','vehicle_mass','request_response_indication']
  _slot_types = ['etsi_its_denm_ts_msgs/HeightLonCarr','etsi_its_denm_ts_msgs/HeightLonCarr','etsi_its_denm_ts_msgs/PosLonCarr','etsi_its_denm_ts_msgs/PosLonCarr','etsi_its_denm_ts_msgs/PositionOfPillars','etsi_its_denm_ts_msgs/PosCentMass','etsi_its_denm_ts_msgs/WheelBaseVehicle','etsi_its_denm_ts_msgs/TurningRadius','etsi_its_denm_ts_msgs/PosFrontAx','etsi_its_denm_ts_msgs/PositionOfOccupants','etsi_its_denm_ts_msgs/VehicleMass','etsi_its_denm_ts_msgs/RequestResponseIndication']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       height_lon_carr_left,height_lon_carr_right,pos_lon_carr_left,pos_lon_carr_right,position_of_pillars,pos_cent_mass,wheel_base_vehicle,turning_radius,pos_front_ax,position_of_occupants,vehicle_mass,request_response_indication

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ImpactReductionContainer, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.height_lon_carr_left is None:
        self.height_lon_carr_left = etsi_its_denm_ts_msgs.msg.HeightLonCarr()
      if self.height_lon_carr_right is None:
        self.height_lon_carr_right = etsi_its_denm_ts_msgs.msg.HeightLonCarr()
      if self.pos_lon_carr_left is None:
        self.pos_lon_carr_left = etsi_its_denm_ts_msgs.msg.PosLonCarr()
      if self.pos_lon_carr_right is None:
        self.pos_lon_carr_right = etsi_its_denm_ts_msgs.msg.PosLonCarr()
      if self.position_of_pillars is None:
        self.position_of_pillars = etsi_its_denm_ts_msgs.msg.PositionOfPillars()
      if self.pos_cent_mass is None:
        self.pos_cent_mass = etsi_its_denm_ts_msgs.msg.PosCentMass()
      if self.wheel_base_vehicle is None:
        self.wheel_base_vehicle = etsi_its_denm_ts_msgs.msg.WheelBaseVehicle()
      if self.turning_radius is None:
        self.turning_radius = etsi_its_denm_ts_msgs.msg.TurningRadius()
      if self.pos_front_ax is None:
        self.pos_front_ax = etsi_its_denm_ts_msgs.msg.PosFrontAx()
      if self.position_of_occupants is None:
        self.position_of_occupants = etsi_its_denm_ts_msgs.msg.PositionOfOccupants()
      if self.vehicle_mass is None:
        self.vehicle_mass = etsi_its_denm_ts_msgs.msg.VehicleMass()
      if self.request_response_indication is None:
        self.request_response_indication = etsi_its_denm_ts_msgs.msg.RequestResponseIndication()
    else:
      self.height_lon_carr_left = etsi_its_denm_ts_msgs.msg.HeightLonCarr()
      self.height_lon_carr_right = etsi_its_denm_ts_msgs.msg.HeightLonCarr()
      self.pos_lon_carr_left = etsi_its_denm_ts_msgs.msg.PosLonCarr()
      self.pos_lon_carr_right = etsi_its_denm_ts_msgs.msg.PosLonCarr()
      self.position_of_pillars = etsi_its_denm_ts_msgs.msg.PositionOfPillars()
      self.pos_cent_mass = etsi_its_denm_ts_msgs.msg.PosCentMass()
      self.wheel_base_vehicle = etsi_its_denm_ts_msgs.msg.WheelBaseVehicle()
      self.turning_radius = etsi_its_denm_ts_msgs.msg.TurningRadius()
      self.pos_front_ax = etsi_its_denm_ts_msgs.msg.PosFrontAx()
      self.position_of_occupants = etsi_its_denm_ts_msgs.msg.PositionOfOccupants()
      self.vehicle_mass = etsi_its_denm_ts_msgs.msg.VehicleMass()
      self.request_response_indication = etsi_its_denm_ts_msgs.msg.RequestResponseIndication()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_4B().pack(_x.height_lon_carr_left.value, _x.height_lon_carr_right.value, _x.pos_lon_carr_left.value, _x.pos_lon_carr_right.value))
      length = len(self.position_of_pillars.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.position_of_pillars.array:
        _x = val1.value
        buff.write(_get_struct_B().pack(_x))
      _x = self
      buff.write(_get_struct_4B().pack(_x.pos_cent_mass.value, _x.wheel_base_vehicle.value, _x.turning_radius.value, _x.pos_front_ax.value))
      _x = self.position_of_occupants.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_BHB().pack(_x.position_of_occupants.bits_unused, _x.vehicle_mass.value, _x.request_response_indication.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.height_lon_carr_left is None:
        self.height_lon_carr_left = etsi_its_denm_ts_msgs.msg.HeightLonCarr()
      if self.height_lon_carr_right is None:
        self.height_lon_carr_right = etsi_its_denm_ts_msgs.msg.HeightLonCarr()
      if self.pos_lon_carr_left is None:
        self.pos_lon_carr_left = etsi_its_denm_ts_msgs.msg.PosLonCarr()
      if self.pos_lon_carr_right is None:
        self.pos_lon_carr_right = etsi_its_denm_ts_msgs.msg.PosLonCarr()
      if self.position_of_pillars is None:
        self.position_of_pillars = etsi_its_denm_ts_msgs.msg.PositionOfPillars()
      if self.pos_cent_mass is None:
        self.pos_cent_mass = etsi_its_denm_ts_msgs.msg.PosCentMass()
      if self.wheel_base_vehicle is None:
        self.wheel_base_vehicle = etsi_its_denm_ts_msgs.msg.WheelBaseVehicle()
      if self.turning_radius is None:
        self.turning_radius = etsi_its_denm_ts_msgs.msg.TurningRadius()
      if self.pos_front_ax is None:
        self.pos_front_ax = etsi_its_denm_ts_msgs.msg.PosFrontAx()
      if self.position_of_occupants is None:
        self.position_of_occupants = etsi_its_denm_ts_msgs.msg.PositionOfOccupants()
      if self.vehicle_mass is None:
        self.vehicle_mass = etsi_its_denm_ts_msgs.msg.VehicleMass()
      if self.request_response_indication is None:
        self.request_response_indication = etsi_its_denm_ts_msgs.msg.RequestResponseIndication()
      end = 0
      _x = self
      start = end
      end += 4
      (_x.height_lon_carr_left.value, _x.height_lon_carr_right.value, _x.pos_lon_carr_left.value, _x.pos_lon_carr_right.value,) = _get_struct_4B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.position_of_pillars.array = []
      for i in range(0, length):
        val1 = etsi_its_denm_ts_msgs.msg.PosPillar()
        start = end
        end += 1
        (val1.value,) = _get_struct_B().unpack(str[start:end])
        self.position_of_pillars.array.append(val1)
      _x = self
      start = end
      end += 4
      (_x.pos_cent_mass.value, _x.wheel_base_vehicle.value, _x.turning_radius.value, _x.pos_front_ax.value,) = _get_struct_4B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.position_of_occupants.value = str[start:end]
      _x = self
      start = end
      end += 4
      (_x.position_of_occupants.bits_unused, _x.vehicle_mass.value, _x.request_response_indication.value,) = _get_struct_BHB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_4B().pack(_x.height_lon_carr_left.value, _x.height_lon_carr_right.value, _x.pos_lon_carr_left.value, _x.pos_lon_carr_right.value))
      length = len(self.position_of_pillars.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.position_of_pillars.array:
        _x = val1.value
        buff.write(_get_struct_B().pack(_x))
      _x = self
      buff.write(_get_struct_4B().pack(_x.pos_cent_mass.value, _x.wheel_base_vehicle.value, _x.turning_radius.value, _x.pos_front_ax.value))
      _x = self.position_of_occupants.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_BHB().pack(_x.position_of_occupants.bits_unused, _x.vehicle_mass.value, _x.request_response_indication.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.height_lon_carr_left is None:
        self.height_lon_carr_left = etsi_its_denm_ts_msgs.msg.HeightLonCarr()
      if self.height_lon_carr_right is None:
        self.height_lon_carr_right = etsi_its_denm_ts_msgs.msg.HeightLonCarr()
      if self.pos_lon_carr_left is None:
        self.pos_lon_carr_left = etsi_its_denm_ts_msgs.msg.PosLonCarr()
      if self.pos_lon_carr_right is None:
        self.pos_lon_carr_right = etsi_its_denm_ts_msgs.msg.PosLonCarr()
      if self.position_of_pillars is None:
        self.position_of_pillars = etsi_its_denm_ts_msgs.msg.PositionOfPillars()
      if self.pos_cent_mass is None:
        self.pos_cent_mass = etsi_its_denm_ts_msgs.msg.PosCentMass()
      if self.wheel_base_vehicle is None:
        self.wheel_base_vehicle = etsi_its_denm_ts_msgs.msg.WheelBaseVehicle()
      if self.turning_radius is None:
        self.turning_radius = etsi_its_denm_ts_msgs.msg.TurningRadius()
      if self.pos_front_ax is None:
        self.pos_front_ax = etsi_its_denm_ts_msgs.msg.PosFrontAx()
      if self.position_of_occupants is None:
        self.position_of_occupants = etsi_its_denm_ts_msgs.msg.PositionOfOccupants()
      if self.vehicle_mass is None:
        self.vehicle_mass = etsi_its_denm_ts_msgs.msg.VehicleMass()
      if self.request_response_indication is None:
        self.request_response_indication = etsi_its_denm_ts_msgs.msg.RequestResponseIndication()
      end = 0
      _x = self
      start = end
      end += 4
      (_x.height_lon_carr_left.value, _x.height_lon_carr_right.value, _x.pos_lon_carr_left.value, _x.pos_lon_carr_right.value,) = _get_struct_4B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.position_of_pillars.array = []
      for i in range(0, length):
        val1 = etsi_its_denm_ts_msgs.msg.PosPillar()
        start = end
        end += 1
        (val1.value,) = _get_struct_B().unpack(str[start:end])
        self.position_of_pillars.array.append(val1)
      _x = self
      start = end
      end += 4
      (_x.pos_cent_mass.value, _x.wheel_base_vehicle.value, _x.turning_radius.value, _x.pos_front_ax.value,) = _get_struct_4B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.position_of_occupants.value = str[start:end]
      _x = self
      start = end
      end += 4
      (_x.position_of_occupants.bits_unused, _x.vehicle_mass.value, _x.request_response_indication.value,) = _get_struct_BHB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_4B = None
def _get_struct_4B():
    global _struct_4B
    if _struct_4B is None:
        _struct_4B = struct.Struct("<4B")
    return _struct_4B
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_BHB = None
def _get_struct_BHB():
    global _struct_BHB
    if _struct_BHB is None:
        _struct_BHB = struct.Struct("<BHB")
    return _struct_BHB
