# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_denm_ts_msgs/LocationContainer.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_denm_ts_msgs.msg

class LocationContainer(genpy.Message):
  _md5sum = "90e3044d79010d04c793b44b431292ab"
  _type = "etsi_its_denm_ts_msgs/LocationContainer"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This type represents the Location Container.
#  *
#  * It shall include the following components: 
#  *
#  * @field eventSpeed: optional speed of a detected dynamic event and the confidence of the speed information. 
#  *
#  * @field eventPositionHeading: the optional heading of a dynamic event and the confidence of the heading information.
#  *
#  * @field detectionZonesToEventPosition: the detection zone information approaching the event position, see clause 6.1.3.3.
#  *
#  * @field roadType: the optional road type information at the event position. 
#  *
#  * @field lanePositions: the optional lane(s) where the event is located, at the position indicated by the component eventPosition 
#  * of the Management container and for a given reference direction.
#  *
#  * @field occupiedLanes: the optional lane(s) that are fully or partially occupied by the event, at the position indicated by the 
#  * component eventPosition of the Management container and for a given reference direction.
#  *
#  * @field linkedIvims: the optional list of DF IvimReference, pointing to IVIMs that are semantically connected because providing information 
#  * applying to the road segment(s) covered by the components detectionZonesToEventPosition, detectionZonesToSpecifiedEventPoint and 
#  * the SituationContainer component eventZone.
#  *
#  * @field linkedMapem: the optional list of DF Mapreference, pointing to MAPEMs that are semantically connected because providing information 
#  * applying to the road segment(s) covered by the component detectionZonesToEventPosition, detectionZonesToSpecifiedEventPoint and 
#  * the SituationContainer component eventZone.
#  *
#  * @field detectionZonesToSpecifiedEventPoint: the optional detection zone information approaching towards a 
#  * specified event point, see clause 6.1.3.3. 
#  *
#  * @field predictedPaths: the optional list of future paths or trajectories that the event may move along or zones that the event may occupy. 
#  *
# */
# LocationContainer ::= SEQUENCE {
#     eventSpeed                            Speed OPTIONAL,
#     eventPositionHeading                  Wgs84Angle OPTIONAL,
#     detectionZonesToEventPosition         Traces,
#     roadType                              RoadType OPTIONAL,
#     ...,
# [[	lanePositions                         GeneralizedLanePositions OPTIONAL,
#     occupiedLanes                         OccupiedLanesWithConfidence OPTIONAL,
#     linkedIvims                           IvimReferences OPTIONAL, 
#     linkedMapems                          MapReferences OPTIONAL, 
#     detectionZonesToSpecifiedEventPoint   TracesExtended OPTIONAL,
#     predictedPaths	          	          PathPredictedList OPTIONAL ]]
# }
# ------------------------------------------------------------------------------

Speed event_speed
bool event_speed_is_present

Wgs84Angle event_position_heading
bool event_position_heading_is_present

Traces detection_zones_to_event_position

RoadType road_type
bool road_type_is_present

GeneralizedLanePositions lane_positions
bool lane_positions_is_present

OccupiedLanesWithConfidence occupied_lanes
bool occupied_lanes_is_present

IvimReferences linked_ivims
bool linked_ivims_is_present

MapReferences linked_mapems
bool linked_mapems_is_present

TracesExtended detection_zones_to_specified_event_point
bool detection_zones_to_specified_event_point_is_present

PathPredictedList predicted_paths
bool predicted_paths_is_present


================================================================================
MSG: etsi_its_denm_ts_msgs/Speed
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents the speed and associated confidence value.
#  *
#  * It shall include the following components: 
#  * 
#  * @field speedValue: the speed value.
#  * 
#  * @field speedConfidence: the confidence value of the speed value.
#  *
#  * @category: Kinematic information
#  * @revision: V1.3.1
#  */
# Speed ::= SEQUENCE {
#     speedValue         SpeedValue,
#     speedConfidence    SpeedConfidence
# }
# ------------------------------------------------------------------------------

SpeedValue speed_value

SpeedConfidence speed_confidence


================================================================================
MSG: etsi_its_denm_ts_msgs/SpeedValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents a speed value, i.e. the magnitude of the velocity-vector. 
#  *
#  * The value shall be set to:
#  * - `0` in a standstill situation.
#  * - `n` (`n > 0` and `n < 16 382`) if the applicable value is equal to or less than n x 0,01 m/s, and greater than (n-1) x 0,01 m/s,
#  * - `16 382` for speed values greater than 163,81 m/s,
#  * - `16 383` if the speed accuracy information is not available.
#  * 
#  * @note: the definition of standstill is out of scope of the present document.
#  *
#  * @unit: 0,01 m/s
#  * @category: Kinematic information
#  * @revision: Description revised in V2.1.1 (the meaning of 16382 has changed slightly) 
# */
# SpeedValue ::= INTEGER {
#     standstill  (0), 
#     outOfRange  (16382), 
#     unavailable (16383)
# } (0..16383)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 16383
uint16 STANDSTILL = 0
uint16 OUT_OF_RANGE = 16382
uint16 UNAVAILABLE = 16383


================================================================================
MSG: etsi_its_denm_ts_msgs/SpeedConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the speed confidence value which represents the estimated absolute accuracy of a speed value with a default confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  * 
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 126`) if the confidence value is equal to or less than n * 0,01 m/s.
#  * - `126` if the confidence value is out of range, i.e. greater than 1,25 m/s,
#  * - `127` if the confidence value information is not available.
#  *  
#  * @note: The fact that a speed value is received with confidence value set to `unavailable(127)` can be caused by several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the speed value may be valid and used by the application.
#  * 
#  * @note: If a speed value is received and its confidence value is set to `outOfRange(126)`, it means that the speed value is not valid 
#  * and therefore cannot be trusted. Such is not useful for the application.
#  *
#  * @unit: 0,01 m/s
#  * @category: Vehicle information
#  * @revision: Description revised in V2.1.1 
#  */
# SpeedConfidence ::= INTEGER {
#     outOfRange  (126), 
#     unavailable (127)
# } (1..127)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 127
uint8 OUT_OF_RANGE = 126
uint8 UNAVAILABLE = 127


================================================================================
MSG: etsi_its_denm_ts_msgs/Wgs84Angle
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF represents an angular component along with a confidence value in the WGS84 coordinate system.
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  *
#  * It shall include the following components: 
#  *
#  * @field value: the angle value, which can be estimated as the mean of the current distribution.
#  *
#  * @field confidence: the confidence value associated to the angle value.
#  *
#  * @category: GeoReference information
#  * @revision: Created in V2.1.1
# */
# Wgs84Angle ::= SEQUENCE {
#     value         Wgs84AngleValue,
#     confidence    Wgs84AngleConfidence
# }
# ------------------------------------------------------------------------------

Wgs84AngleValue value

Wgs84AngleConfidence confidence


================================================================================
MSG: etsi_its_denm_ts_msgs/Wgs84AngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents an angle value in degrees described in the WGS84 reference system with respect to the WGS84 north.
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.
#  *
#  * @unit 0,1 degrees
#  * @category: GeoReference Information
#  * @revision: Created in V2.1.1
# */
# Wgs84AngleValue ::= INTEGER { 
#     wgs84North  (0),
#     wgs84East   (900),
#     wgs84South  (1800),
#     wgs84West   (2700),
#     doNotUse    (3600),
#     unavailable (3601)
# } (0..3601)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 WGS84_NORTH = 0
uint16 WGS84_EAST = 900
uint16 WGS84_SOUTH = 1800
uint16 WGS84_WEST = 2700
uint16 DO_NOT_USE = 3600
uint16 UNAVAILABLE = 3601


================================================================================
MSG: etsi_its_denm_ts_msgs/Wgs84AngleConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE indicates the angle confidence value which represents the estimated accuracy of an angle value with a default confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  * 
#  * The value shall be set to:
#  * - `n` (`n >= 1` and `n < 126`) if the confidence value is equal to or less than n x 0,1 degrees and more than (n-1) x 0,1 degrees,
#  * - `126` if the confidence value is out of range, i.e. greater than 12,5 degrees,
#  * - `127` if the confidence value is not available.
#  *
#  *
#  * @unit 0,1 degrees
#  * @category: GeoReference Information
#  * @revision: Created in V2.1.1
# */
# Wgs84AngleConfidence ::= INTEGER {
#     outOfRange  (126), 
#     unavailable (127)  
# } (1..127)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 127
uint8 OUT_OF_RANGE = 126
uint8 UNAVAILABLE = 127


================================================================================
MSG: etsi_its_denm_ts_msgs/Traces
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents one or more paths using @ref Path.
#  * 
#  * @category: GeoReference information
#  * @revision: Description revised in V2.1.1. Is is now based on Path and not on PathHistory
#  */
# Traces ::= SEQUENCE SIZE(1..7) OF Path
# ------------------------------------------------------------------------------

Path[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 7


================================================================================
MSG: etsi_its_denm_ts_msgs/Path
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a path with a set of path points.
#  * It shall contain up to `40` @ref PathPoint. 
#  * 
#  * The first PathPoint presents an offset delta position with regards to an external reference position.
#  * Each other PathPoint presents an offset delta position and optionally an offset travel time with regards to the previous PathPoint. 
#  *
#  * @category: GeoReference information, Vehicle information
#  * @revision: created in V2.1.1 based on PathHistory
#  */
# Path::= SEQUENCE (SIZE(0..40)) OF PathPoint
# ------------------------------------------------------------------------------

PathPoint[] array
uint8 MIN_SIZE = 0
uint8 MAX_SIZE = 40


================================================================================
MSG: etsi_its_denm_ts_msgs/PathPoint
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF defines an offset waypoint position within a path.
#  *
#  * It shall include the following components: 
#  *
#  * @field pathPosition: The waypoint position defined as an offset position with regards to a pre-defined reference position. 
#  *
#  * @field pathDeltaTime: The optional travel time separated from a waypoint to the predefined reference position.
#  *
#  * @category GeoReference information
#  * @revision: semantics updated in V2.1.1
#  */
# PathPoint ::= SEQUENCE {
#     pathPosition     DeltaReferencePosition,
#     pathDeltaTime    PathDeltaTime OPTIONAL
# }
# ------------------------------------------------------------------------------

DeltaReferencePosition path_position

PathDeltaTime path_delta_time
bool path_delta_time_is_present


================================================================================
MSG: etsi_its_denm_ts_msgs/DeltaReferencePosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF defines a geographical point position as a 3 dimensional offset position to a geographical reference point.
#  *
#  * It shall include the following components: 
#  *
#  * @field deltaLatitude: A delta latitude offset with regards to the latitude value of the reference position.
#  *
#  * @field deltaLongitude: A delta longitude offset with regards to the longitude value of the reference position.
#  *
#  * @field deltaAltitude: A delta altitude offset with regards to the altitude value of the reference position.
#  *
#  * @category: GeoReference information
#  * @revision:  V1.3.1
#  */
# DeltaReferencePosition ::= SEQUENCE {
#     deltaLatitude     DeltaLatitude,
#     deltaLongitude    DeltaLongitude,
#     deltaAltitude     DeltaAltitude
# }
# ------------------------------------------------------------------------------

DeltaLatitude delta_latitude

DeltaLongitude delta_longitude

DeltaAltitude delta_altitude


================================================================================
MSG: etsi_its_denm_ts_msgs/DeltaLatitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents an offset latitude with regards to a defined latitude value.
#  * It may be used to describe a geographical point with regards to a specific reference geographical position.
#  *
#  * The value shall be set to:
#  * - `n` (`n >= -131 071` and `n < 0`) for offset n x 10^-7 degree towards the south from the reference position,
#  * - `0` for no latitudinal offset,
#  * - `n` (`n > 0` and `n < 131 072`) for offset n x 10^-7 degree towards the north from the reference position,
#  * - `131 072` when the information is unavailable.
#  *
#  * @unit: 10^-7 degree
#  * @category: GeoReference information
#  * @revision: editorial update in V2.1.1
#  */
# DeltaLatitude ::= INTEGER {
#     unavailable (131072)
# } (-131071..131072)
# ------------------------------------------------------------------------------

int32 value
int32 MIN = -131071
int32 MAX = 131072
int32 UNAVAILABLE = 131072


================================================================================
MSG: etsi_its_denm_ts_msgs/DeltaLongitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents an offset longitude with regards to a defined longitude value.
#  * It may be used to describe a geographical point with regards to a specific reference geographical position.
#  *
#  * The value shall be set to:
#  * - `n` (`n >= -131 071` and `n < 0`) for offset n x 10^-7 degree towards the west from the reference position,
#  * - `0` for no longitudinal offset,
#  * - `n` (`n > 0` and `n < 131 072`) for offset n x 10^-7 degree towards the east from the reference position, 
#  * - `131 072` when the information is unavailable.
#  *
#  * @unit: 10^-7 degree
#  * @category: GeoReference information
#  * @revision: editorial update in V2.1.1
#  */
# DeltaLongitude ::= INTEGER {
#     unavailable (131072)
# } (-131071..131072)
# ------------------------------------------------------------------------------

int32 value
int32 MIN = -131071
int32 MAX = 131072
int32 UNAVAILABLE = 131072


================================================================================
MSG: etsi_its_denm_ts_msgs/DeltaAltitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents an offset altitude with regards to a defined altitude value.
#  * It may be used to describe a geographical point with regards to a specific reference geographical position.
#  *
#  * The value shall be set to:
#  * - `-12 700` for values equal to or lower than -127 metres,
#  * - `n` (`n > -12 700` and `n <= 0`) for altitude offset n x 0,01 metre below the reference position,
#  * - `0` for no altitudinal offset,
#  * - `n` (`n > 0` and `n < 12799`) for altitude offset n x 0,01 metre above the reference position,
#  * - `12 799` for values equal to or greater than 127,99 metres,
#  * - `12 800` when the information is unavailable.
#  *
#  * @unit: 0,01 metre
#  * @category: GeoReference information
#  * @revision: editorial update in V2.1.1
#  */
# DeltaAltitude ::= INTEGER {
#     negativeOutOfRange (-12700),
#     positiveOutOfRange (12799),
#     unavailable        (12800)
# } (-12700..12800)
# ------------------------------------------------------------------------------

int16 value
int16 MIN = -12700
int16 MAX = 12800
int16 NEGATIVE_OUT_OF_RANGE = -12700
int16 POSITIVE_OUT_OF_RANGE = 12799
int16 UNAVAILABLE = 12800


================================================================================
MSG: etsi_its_denm_ts_msgs/PathDeltaTime
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the recorded or estimated travel time between a position and a predefined reference position. 
#  *
#  * @unit 0,01 second
#  * @category: Basic information
#  * @revision: V1.3.1
#  */
# PathDeltaTime ::= INTEGER (1..65535, ...) 
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 1
uint16 MAX = 65535


================================================================================
MSG: etsi_its_denm_ts_msgs/RoadType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the type of a road segment.
#  * 
#  * The value shall be set to:
#  * - 0 `urban-NoStructuralSeparationToOppositeLanes`       - for an urban road with no structural separation between lanes carrying traffic in opposite directions,
#  * - 1 `urban-WithStructuralSeparationToOppositeLanes`     - for an urban road with structural separation between lanes carrying traffic in opposite directions,
#  * - 2 `nonUrban-NoStructuralSeparationToOppositeLanes`    - for an non urban road with no structural separation between lanes carrying traffic in opposite directions,
#  * - 3 `nonUrban-WithStructuralSeparationToOppositeLanes`  - for an non urban road with structural separation between lanes carrying traffic in opposite directions.
#  *
#  * @category: Road Topology Information
#  * @revision: Editorial update in V2.1.1
#  */
# RoadType ::= ENUMERATED {
#     urban-NoStructuralSeparationToOppositeLanes      (0),
#     urban-WithStructuralSeparationToOppositeLanes    (1),
#     nonUrban-NoStructuralSeparationToOppositeLanes   (2),
#     nonUrban-WithStructuralSeparationToOppositeLanes (3)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 URBAN_NO_STRUCTURAL_SEPARATION_TO_OPPOSITE_LANES = 0
uint8 URBAN_WITH_STRUCTURAL_SEPARATION_TO_OPPOSITE_LANES = 1
uint8 NON_URBAN_NO_STRUCTURAL_SEPARATION_TO_OPPOSITE_LANES = 2
uint8 NON_URBAN_WITH_STRUCTURAL_SEPARATION_TO_OPPOSITE_LANES = 3


================================================================================
MSG: etsi_its_denm_ts_msgs/GeneralizedLanePositions
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents transversal position information with respect to the road, at an externally defined reference position. It shall contain a set of up to `4` @ref GeneralizedLanePosition.
#  * Multiple entries can be used to describe several lane positions with the associated confidence, in cases where the reference position cannot be mapped to a single lane.
#  *
#  * @category: Road Topology information
#  * @revision: Created in V2.2.1
#  */
# GeneralizedLanePositions ::= SEQUENCE (SIZE(1..4)) OF GeneralizedLanePosition
# ------------------------------------------------------------------------------

GeneralizedLanePosition[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 4


================================================================================
MSG: etsi_its_denm_ts_msgs/GeneralizedLanePosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents the top-level DF to represent a lane position. A lane position is a transversal position on the carriageway at a specific longitudinal position, in resolution of lanes of the carriageway.
#  *
#  * @note: This DF is the most general way to represent a lane position: it provides a complete set of information regarding a transversal (dimensionless) position on the carriageway at a specific 
#  * reference position, i.e. it provides different options and synonyms to represent the lane at which the reference position (the point) is located. A confidence is used to describe the probability 
#  * that the object is located in the provided lane. The dimension of the object or extension of an area are not considered: See @ref OccupiedLanesWithConfidence for describing the occupation of lanes, 
#  * where the dimensions of an object or the extension of an area is considered.
#  *
#  * It shall include the following components: 
#  *
#  * @field lanePositionBased: lane position information for a defined reference position.
#  * 
#  * @field mapBased: optional lane position information described in the context of a MAPEM as specified in ETSI TS 103 301 [15]. 
#  * If present, it shall describe the same reference position using the lane identification in the MAPEM. This component can be used only if a MAPEM is available for the reference position 
#  * (e.g. on an intersection): In this case it is used as a synonym to the mandatory component lanePositionBased. 
#  * 
#  * @field confidence: confidence information for expressing the probability that the object is located at the indicated lane.  
#  * If the value of the component lanePositionBased is generated directly from the absolute reference position and reference topology information, 
#  * no sensor shall be indicated in the component usedDetectionInformation of the @ref MetaInformation.
#  *
#  * @category: Road Topology information
#  * @revision: newly created in V2.2.1. The previous DF GeneralizedLanePosition is now renamed to @ref LanePositionOptions. 
#  */
# GeneralizedLanePosition ::= SEQUENCE {
#     lanePositionBased     LanePositionOptions,
#     mapBased              MapPosition OPTIONAL,
#     confidence            MetaInformation,
#     ... 
# }
# ------------------------------------------------------------------------------

LanePositionOptions lane_position_based

MapPosition map_based
bool map_based_is_present

MetaInformation confidence


================================================================================
MSG: etsi_its_denm_ts_msgs/LanePositionOptions
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a set of options to describe a lane position and is the second level DF to represent a lane position. The top-level DFs are @ref GeneralizedLanePosition or @ref OccupiedLanesWithConfidence. 
#  * A lane position is a transversal position on the carriageway at a specific longitudinal position, in resolution of lanes of the carriageway.
#  *
#  * The following options are available:
#  *
#  * @field simplelanePosition: a single lane position without any additional context information.
#  *
#  * @field simpleLaneType: a lane type, to be used when the lane position is unknown but the type of lane is known. This can be used in scenarios where a certain confidence about the used lane type is given 
#  * but no or limited knowledge about the absolute lane number is available. For example, a cyclist on a cycle-lane or vehicles on a specific lane that is unique for the part of the road (e.g. a bus lane).
#  * 
#  * @field detailedlanePosition: a single lane position with additional lane details.
#  * 
#  * @field lanePositionWithLateralDetails: a single lane position with additional details and the lateral position within the lane.
#  *
#  * @field trafficIslandPosition: a position on a traffic island, i.e. between two lanes. 
#  *
#  * @category: Road Topology information
#  * @revision: Created in V2.2.1 from the DF GeneralizedLanePosition of V2.1.1. 
#  */
# LanePositionOptions ::= CHOICE {
#     simplelanePosition                   LanePosition,
#     simpleLaneType                       LaneType,
#     detailedlanePosition                 LanePositionAndType,
#     lanePositionWithLateralDetails       LanePositionWithLateralDetails,
#     trafficIslandPosition                TrafficIslandPosition,
#     ...
# }
# ------------------------------------------------------------------------------

uint8 choice

LanePosition simplelane_position
uint8 CHOICE_SIMPLELANE_POSITION = 0

LaneType simple_lane_type
uint8 CHOICE_SIMPLE_LANE_TYPE = 1

LanePositionAndType detailedlane_position
uint8 CHOICE_DETAILEDLANE_POSITION = 2

LanePositionWithLateralDetails lane_position_with_lateral_details
uint8 CHOICE_LANE_POSITION_WITH_LATERAL_DETAILS = 3

TrafficIslandPosition traffic_island_position
uint8 CHOICE_TRAFFIC_ISLAND_POSITION = 4


================================================================================
MSG: etsi_its_denm_ts_msgs/LanePosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates a transversal position on the carriageway at a specific longitudinal position, in resolution of lanes of the carriageway. 
#  *
#  * For right-hand traffic roads, the value shall be set to:
#  * - `-1` if the position is off, i.e. besides the road,
#  * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the leftmost lane,
#  * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the leftmost lane to the rightmost lane of a specific traffic direction,
#  * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to rightmost lane (if present).
#  *
#  * For left-hand traffic roads, the value shall be set to:
#  * - `-1` if the position is off, i.e. besides the road,
#  * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the rightmost lane,
#  * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the rightmost lane to the leftmost lane of a specific traffic direction,
#  * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to leftmost lane (if present).
#  *
#  *  @note: in practice this means that the position is counted from "inside" to "outside" no matter which traffic practice is used.
#  *
#  * If the carriageway allows only traffic in one direction (e.g. in case of dual or multiple carriageway roads), the position is counted from the physical border of the carriageway. 
#  * If the carriageway allows traffic in both directions and there is no physical delimitation between traffic directions (e.g. on a single carrriageway road), 
#  * the position is counted from the legal (i.e. optical) separation between traffic directions (horizontal marking). 
#  *
#  * If not indicated otherwise (by lane markings or traffic signs), the legal separation on carriageways allowing traffic on both directions is identified as follows:
#  * - If the total number of lanes N is even, the lanes are divided evenly between the traffic directions starting from the outside of the carriageway on both sides and the 
#  *   imaginary separation between traffic directions is on the border between the even number of lanes N/2.
#  * - If the total number of lanes N is odd, the lanes are divided evenly between traffic direction starting from the outside of the carriageway on both sides. 
#  *   The remaining middle lane is assigned to both traffic directions as innermost lane.
#  *
#  * @category: Road topology information
#  * @revision: Description of the legal separation of carriageways added in V2.2.1
# */
# LanePosition ::= INTEGER {
#     offTheRoad           (-1), 
#     innerHardShoulder    (0), 
#     outerHardShoulder    (14) 
# } (-1..14)
# ------------------------------------------------------------------------------

int8 value
int8 MIN = -1
int8 MAX = 14
int8 OFF_THE_ROAD = -1
int8 INNER_HARD_SHOULDER = 0
int8 OUTER_HARD_SHOULDER = 14


================================================================================
MSG: etsi_its_denm_ts_msgs/LaneType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the type of a lane. 
#  * 
#  * The value shall be set to:
#  * - 0	- `traffic`            - Lane dedicated to the movement of vehicles,
#  * - 1	- `through`            - Lane dedicated to the movement of vehicles travelling ahead and not turning,
#  * - 2	- `reversible`         - Lane where the direction of traffic can be changed to match the peak flow,
#  * - 3	- `acceleration`	   - Lane that allows vehicles entering a road to accelerate to the speed of through traffic before merging with it,
#  * - 4	- `deceleration`       - Lane that allows vehicles exiting a road to decelerate before leaving it,
#  * - 5	- `leftHandTurning`    - Lane reserved for slowing down and making a left turn, so as not to disrupt traffic,
#  * - 6	- `rightHandTurning`   - Lane reserved for slowing down and making a right turn so as not to disrupt traffic,
#  * - 7	- `dedicatedVehicle`   - Lane dedicated to movement of motor vehicles with specific characteristics, such as heavy goods vehicles, etc., 
#  * - 8	- `bus`                - Lane dedicated to movement of buses providing public transport,
#  * - 9	- `taxi`               - Lane dedicated to movement of taxis,
#  * - 10	- `hov`                - Carpooling lane or high occupancy vehicle lane,
#  * - 11	- `hot`                - High occupancy vehicle lanes that is allowed to be used without meeting the occupancy criteria by paying a toll,
#  * - 12	- `pedestrian`         - Lanes dedicated to pedestrians such as pedestrian sidewalk paths,
#  * - 13	- `cycleLane`	       - Lane dedicated to exclusive or preferred use by bicycles,
#  * - 14	- `median`             - Lane not dedicated to movement of vehicles but representing a median / central reservation  such as the central median, 
#                                  separating the two directional carriageways of the highway,
#  * - 15	- `striping`	       - Lane not dedicated to movement of vehicles but covered with roadway markings,
#  * - 16	- `trackedVehicle`     - Lane dedicated to movement of trains, trams and trolleys,
#  * - 17	- `parking`            - Lanes dedicated to vehicles parking, stopping and loading lanes,
#  * - 18	- `emergency`          - Lane dedicated to vehicles in breakdown or to emergency vehicles also called hard shoulder,
#  * - 19	- `verge`              - Lane representing the verge, i.e. a narrow strip of grass or plants and sometimes also trees located between 
#                                  the road surface edge and the boundary of a road,
#  * - 20	`minimumRiskManoeuvre` - Lane dedicated to automated vehicles making a minimum risk manoeuvre,
#  * - 21	`separatedCycleLane`   - Lane dedicated to exclusive or preferred use by bicycles that is phyisically separated from the vehicle-traffic lanes, e.g. by a verge.
#  * - values 22 to 30             reserved for future use. 
#  *
#  * @category: Road topology information
#  * @revision: Created in V2.1.1, named value 21 added in V2.2.1
# */
# LaneType::= INTEGER{
# 	traffic              (0),
# 	through	             (1),
# 	reversible           (2),
# 	acceleration         (3),
# 	deceleration         (4),
# 	leftHandTurning      (5),
# 	rightHandTurning     (6),
# 	dedicatedVehicle     (7),
# 	bus                  (8),
# 	taxi                 (9),
# 	hov                  (10),
# 	hot                  (11),
# 	pedestrian           (12),
# 	cycleLane            (13),
# 	median               (14),   
# 	striping             (15),
# 	trackedVehicle       (16),
# 	parking	             (17),
# 	emergency            (18),
# 	verge                (19),
# 	minimumRiskManoeuvre (20),
#     exclusiveCycleLane   (21),
# 	unknown              (31)
# }(0..31)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 31
uint8 TRAFFIC = 0
uint8 THROUGH = 1
uint8 REVERSIBLE = 2
uint8 ACCELERATION = 3
uint8 DECELERATION = 4
uint8 LEFT_HAND_TURNING = 5
uint8 RIGHT_HAND_TURNING = 6
uint8 DEDICATED_VEHICLE = 7
uint8 BUS = 8
uint8 TAXI = 9
uint8 HOV = 10
uint8 HOT = 11
uint8 PEDESTRIAN = 12
uint8 CYCLE_LANE = 13
uint8 MEDIAN = 14
uint8 STRIPING = 15
uint8 TRACKED_VEHICLE = 16
uint8 PARKING = 17
uint8 EMERGENCY = 18
uint8 VERGE = 19
uint8 MINIMUM_RISK_MANOEUVRE = 20
uint8 EXCLUSIVE_CYCLE_LANE = 21
uint8 UNKNOWN = 31


================================================================================
MSG: etsi_its_denm_ts_msgs/LanePositionAndType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF indicates a transversal position in resolution of lanes and other associated details.
#  *
#  * It shall include the following components: 
#  * 
#  * @field transversalPosition: the transversal position.
#  * 
#  * @field laneType: the type of the lane identified in the component transversalPosition. By default set to `traffic`.
#  *
#  * @field direction: the traffic direction for the lane position relative to a defined reference direction. By default set to `sameDirection`, i.e. following the reference direction.
#  *
#  * @category Road topology information
#  * @revision: direction added in V2.2.1
#  */
# LanePositionAndType::= SEQUENCE {
#     transversalPosition    LanePosition,
#     laneType               LaneType DEFAULT traffic,
#     direction              Direction DEFAULT sameDirection,
#     ...
# }
# ------------------------------------------------------------------------------

LanePosition transversal_position

LaneType lane_type
uint8 LANE_TYPE_DEFAULT = 0

Direction direction
uint8 DIRECTION_DEFAULT = 0


================================================================================
MSG: etsi_its_denm_ts_msgs/Direction
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates a direction with respect to a defined reference direction.
#  * Example: a reference direction may be implicitly defined by the definition of a geographical zone.
#  *
#  * The value shall be set to:
#  * - 0 - `sameDirection`     - to indicate the same direction as the reference direction,
#  * - 1 - `oppositeDirection` - to indicate opposite direction as the reference direction,
#  * - 2 - `bothDirections`    - to indicate both directions, i.e. the same and the opposite direction,
#  * - 3 - `unavailable`       - to indicate that the information is unavailable.
#  *
#  * @category: GeoReference information
#  * @revision: Created in V2.1.1
#  */
# Direction::= INTEGER{
#     sameDirection     (0),
#     oppositeDirection (1),
#     bothDirections    (2),
#     unavailable       (3)
#  } (0..3)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 3
uint8 SAME_DIRECTION = 0
uint8 OPPOSITE_DIRECTION = 1
uint8 BOTH_DIRECTIONS = 2
uint8 UNAVAILABLE = 3


================================================================================
MSG: etsi_its_denm_ts_msgs/LanePositionWithLateralDetails
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF is a third-level DF that represents a lane position and is an extended version of @ref LanePositionAndType that adds the distances to the left and right lane border.
#  *
#  * It shall additionally include the following components: 
#  *
#  * @field distanceToLeftBorder: the distance of the transversal position to the left lane border. The real value shall be rounded to the next lower encoding-value.
#  *
#  * @field distanceToRightBorder: the distance of the transversal position to the right lane border. The real value shall be rounded to the next lower encoding-value.
#  * 
#  * @category: Road Topology information
#  * @revision: Created in V2.2.1
#  */
# LanePositionWithLateralDetails ::= SEQUENCE {
#     COMPONENTS OF               LanePositionAndType,
#     distanceToLeftBorder        StandardLength9b,
#     distanceToRightBorder       StandardLength9b,
#     ...
# }
# ------------------------------------------------------------------------------

LanePosition transversal_position

LaneType lane_type
uint8 LANE_TYPE_DEFAULT = 0

Direction direction
uint8 DIRECTION_DEFAULT = 0

StandardLength9b distance_to_left_border

StandardLength9b distance_to_right_border


================================================================================
MSG: etsi_its_denm_ts_msgs/StandardLength9b
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * The DE represents length as a measure of distance between points or as a dimension of an object. 
#  *
#  * @unit: 0,1 metre
#  * @category: Basic information
#  * @revision: Created in V2.1.1
#  */
# StandardLength9b::= INTEGER (0..511)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 511


================================================================================
MSG: etsi_its_denm_ts_msgs/TrafficIslandPosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * Ths DF represents the a position on a traffic island between two lanes. 
#  *
#  * It shall include the following components: 
#  *
#  * @field oneSide: represents one lane.
#  * 
#  * @field otherSide: represents the other lane.
#  * 
#  * @category: Road Topology information
#  * @revision: Created in V2.1.1
#  */
# TrafficIslandPosition ::= SEQUENCE {
#     oneSide      LanePositionAndType,
#     otherSide    LanePositionAndType,
#     ...
# }
# ------------------------------------------------------------------------------

LanePositionAndType one_side

LanePositionAndType other_side


================================================================================
MSG: etsi_its_denm_ts_msgs/MapPosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF indicates a position on a topology description transmitted in a MAPEM according to ETSI TS 103 301 [15].
#  *
#  * It shall include the following components: 
#  * 
#  * @field mapReference: optionally identifies the MAPEM containing the topology information.
#  * It is absent if the MAPEM topology is known from the context.
#  * 
#  * @field laneId: optionally identifies the lane in the road segment or intersection topology on which the position is located.
#  *
#  * @field connectionId: optionally identifies the connection inside the conflict area of an intersection, i.e. it identifies a trajectory for travelling through the
#  * conflict area of an intersection which connects e.g an ingress with an egress lane.
#  *
#  * @field longitudinalLanePosition: optionally indicates the longitudinal offset of the map-matched position of the object along the lane or connection measured from the start of the lane/connection, along the lane.
#  * 
#  * @category: Road topology information
#  * @revision: Created in V2.1.1, definition of longitudinalLanePosition amended in V2.2.1
#  */
# MapPosition ::= SEQUENCE {
#     mapReference                MapReference OPTIONAL,
#     laneId                      Identifier1B OPTIONAL,
#     connectionId                Identifier1B OPTIONAL, 
#     longitudinalLanePosition    LongitudinalLanePosition OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------

MapReference map_reference
bool map_reference_is_present

Identifier1B lane_id
bool lane_id_is_present

Identifier1B connection_id
bool connection_id_is_present

LongitudinalLanePosition longitudinal_lane_position
bool longitudinal_lane_position_is_present


================================================================================
MSG: etsi_its_denm_ts_msgs/MapReference
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF provides the reference to the information contained in a MAPEM according to ETSI TS 103 301 [15]. 
#  *
#  * The following options are provided:
#  * 
#  * @field roadsegment: option that identifies the description of a road segment contained in a MAPEM.
#  * 
#  * @field intersection: option that identifies the description of an intersection contained in a MAPEM.
#  *
#  * @category: Road topology information
#  * @revision: Created in V2.1.1
#  */
# MapReference::= CHOICE {
# 	roadsegment     RoadSegmentReferenceId,
# 	intersection    IntersectionReferenceId
# }
# ------------------------------------------------------------------------------

uint8 choice

RoadSegmentReferenceId roadsegment
uint8 CHOICE_ROADSEGMENT = 0

IntersectionReferenceId intersection
uint8 CHOICE_INTERSECTION = 1


================================================================================
MSG: etsi_its_denm_ts_msgs/RoadSegmentReferenceId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a unique id for a road segment
#  *
#  * It shall include the following components: 
#  *
#  * @field region: the optional identifier of the entity that is responsible for the region in which the road segment is placed.
#  * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
#  *
#  * @field id: the identifier of the road segment.
#  *
#  * @note: when the component region is present, the RoadSegmentReferenceId is guaranteed to be globally unique.
#  * @category: GeoReference information
#  * @revision: created in V2.1.1
#  */
# RoadSegmentReferenceId ::= SEQUENCE {
#     region    Identifier2B OPTIONAL,
#     id        Identifier2B
# }
# ------------------------------------------------------------------------------

Identifier2B region
bool region_is_present

Identifier2B id


================================================================================
MSG: etsi_its_denm_ts_msgs/Identifier2B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE is a general identifier.
#  * 
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# Identifier2B ::= INTEGER (0..65535)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 65535


================================================================================
MSG: etsi_its_denm_ts_msgs/IntersectionReferenceId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a unique id for an intersection, in accordance with ETSI TS 103 301 [15].
#  *
#  * It shall include the following components: 
#  *
#  * @field region: the optional identifier of the entity that is responsible for the region in which the intersection is placed.
#  * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
#  *
#  * @field id: the identifier of the intersection
#  *
#  * @note: when the component region is present, the IntersectionReferenceId is guaranteed to be globally unique.
#  * @category: Road topology information
#  * @revision: created in V2.1.1
#  */
# IntersectionReferenceId ::= SEQUENCE {
#     region    Identifier2B OPTIONAL,
#     id        Identifier2B
# }
# ------------------------------------------------------------------------------

Identifier2B region
bool region_is_present

Identifier2B id


================================================================================
MSG: etsi_its_denm_ts_msgs/Identifier1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE is a general identifier.
#  * 
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# Identifier1B ::= INTEGER (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_denm_ts_msgs/LongitudinalLanePosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF represents the estimated position along the longitudinal extension of a carriageway or lane. 
#  *
#  * It shall include the following components: 
#  *
#  * @field  longitudinalLanePositionValue: the mean value of the longitudinal position along the carriageway or lane w.r.t. an externally defined start position.
#  *
#  * @field  longitudinalLanePositionConfidence: The confidence value associated to the value.
#  *
#  * @category: Road topology information
#  * @revision: created in V2.1.1, description revised in V2.2.1
#  */
# LongitudinalLanePosition ::= SEQUENCE {
#     longitudinalLanePositionValue         LongitudinalLanePositionValue,
#     longitudinalLanePositionConfidence    LongitudinalLanePositionConfidence
# }
# ------------------------------------------------------------------------------

LongitudinalLanePositionValue longitudinal_lane_position_value

LongitudinalLanePositionConfidence longitudinal_lane_position_confidence


================================================================================
MSG: etsi_its_denm_ts_msgs/LongitudinalLanePositionValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents the longitudinal offset of a map-matched position along a matched lane, beginning from the lane's starting point.
#  * 
#  * The value shall be set to:
#  * - `n` (`n >= 0` and `n < 32766`) if the longitudinal offset information is equal to or less than n x 0,1 metre and more than (n-1) x 0,1 metre,
#  * - `32 766` if the longitudinal offset is out of range, i.e. greater than 3276,5 m,
#  * - `32 767` if the longitudinal offset information is not available. 
#  *
#  * @unit 0,1 metre
#  * @category: GeoReference information
#  * @revision: Created in V2.1.1
# */
# LongitudinalLanePositionValue ::= INTEGER {
#     outOfRange(32766),
#     unavailable(32767)
# }(0..32767)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 32767
uint16 OUT_OF_RANGE = 32766
uint16 UNAVAILABLE = 32767


================================================================================
MSG: etsi_its_denm_ts_msgs/LongitudinalLanePositionConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE indicates the longitudinal lane position confidence value which represents the estimated accuracy of longitudinal lane position measurement with a default confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  *
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 1 022`) if the  confidence value is equal to or less than n x 0,1 m, and more than (n-1) x 0,1 m,
#  * - `1 022` if the confidence value is out of range i.e. greater than 102,1 m,
#  * - `1 023` if the confidence value is unavailable.
#  *
#  * @unit 0,1 metre
#  * @category: GeoReference information
#  * @revision: Created in V2.1.1
# */
# LongitudinalLanePositionConfidence ::= INTEGER {
#     outOfRange  (1022),
#     unavailable (1023)  
# } (0..1023)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 1023
uint16 OUT_OF_RANGE = 1022
uint16 UNAVAILABLE = 1023


================================================================================
MSG: etsi_its_denm_ts_msgs/MetaInformation
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF provides information about the source of and confidence in information.
#  *
#  * It shall include the following components: 
#  * 
#  * @field usedDetectionInformation: the type of sensor(s) that is used to provide the detection information.
#  * 
#  * @field usedStoredInformation: the type of source of the stored information. 
#  *
#  * @field confidenceValue: an optional confidence value associated to the information. 
#  * 
#  * @category: Basic information
#  * @revision: Created in V2.2.1
# */
# MetaInformation::=SEQUENCE{		
#   usedDetectionInformation   SensorTypes, 
#   usedStoredInformation      StoredInformationType,
#   confidenceValue            ConfidenceLevel OPTIONAL,
#   ...
# }
# ------------------------------------------------------------------------------

SensorTypes used_detection_information

StoredInformationType used_stored_information

ConfidenceLevel confidence_value
bool confidence_value_is_present


================================================================================
MSG: etsi_its_denm_ts_msgs/SensorTypes
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE indicates the type of sensor(s).
#  * The corresponding bit shall be set to 1 under the following conditions:
#  * 
#  * - 0  `undefined`         - in case the sensor type is undefined. 
#  * - 1  `radar`             - in case the sensor is a radar,
#  * - 2  `lidar`             - in case the sensor is a lidar,
#  * - 3  `monovideo`         - in case the sensor is mono video,
#  * - 4  `stereovision`      - in case the sensor is stereo vision,
#  * - 5  `nightvision`       - in case the sensor is night vision,
#  * - 6  `ultrasonic`        - in case the sensor is ultrasonic,
#  * - 7  `pmd`               - in case the sensor is photonic mixing device,
#  * - 8  `inductionLoop`     - in case the sensor is an induction loop,
#  * - 9  `sphericalCamera`   - in case the sensor is a spherical camera,
#  * - 10 `uwb`               - in case the sensor is ultra wide band,
#  * - 11 `acoustic`          - in case the sensor is acoustic,
#  * - 12 `localAggregation`  - in case the information is provided by a system that aggregates information from different local sensors. Aggregation may include fusion,
#  * - 13 `itsAggregation`    - in case the information is provided by a system that aggregates information from other received ITS messages.
#  * - 14-15                  - are reserved for future usage.
#  * 
#  * @note: If all bits are set to 0, then no sensor type is used
#  *
#  * @category: Sensing Information
#  * @revision: created in V2.2.1
# */
# SensorTypes ::= BIT STRING {
#     undefined         (0),
#     radar             (1),
#     lidar             (2),
#     monovideo         (3),
#     stereovision      (4),
#     nightvision       (5),
#     ultrasonic        (6),
#     pmd               (7),
#     inductionLoop     (8),
#     sphericalCamera   (9),
#     uwb               (10),
#     acoustic          (11),
#     localAggregation  (12),
#     itsAggregation    (13)
# } (SIZE (16,... ))
# ------------------------------------------------------------------------------

uint8[] value
uint8 bits_unused
uint8 SIZE_BITS = 16
uint8 BIT_INDEX_UNDEFINED = 0
uint8 BIT_INDEX_RADAR = 1
uint8 BIT_INDEX_LIDAR = 2
uint8 BIT_INDEX_MONOVIDEO = 3
uint8 BIT_INDEX_STEREOVISION = 4
uint8 BIT_INDEX_NIGHTVISION = 5
uint8 BIT_INDEX_ULTRASONIC = 6
uint8 BIT_INDEX_PMD = 7
uint8 BIT_INDEX_INDUCTION_LOOP = 8
uint8 BIT_INDEX_SPHERICAL_CAMERA = 9
uint8 BIT_INDEX_UWB = 10
uint8 BIT_INDEX_ACOUSTIC = 11
uint8 BIT_INDEX_LOCAL_AGGREGATION = 12
uint8 BIT_INDEX_ITS_AGGREGATION = 13


================================================================================
MSG: etsi_its_denm_ts_msgs/StoredInformationType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE indicates the type of stored information.
#  *
#  * The corresponding bit shall be set to 1 under the following conditions:
#  * 
#  * - `0` undefined        - in case the stored information type is undefined. 
#  * - `1` staticDb         - in case the stored information type is a static database.
#  * - `2` dynamicDb        - in case the stored information type is a dynamic database
#  * - `3` realTimeDb       - in case the stored information type is a real time updated database.
#  * - `4` map              - in case the stored information type is a road topology map.
#  * - Bits 5 to 7          - are reserved for future use.
#  *
#  * @note: If all bits are set to 0, then no stored information type is used
#  *
#  * @category: Basic Information
#  * @revision: created in V2.2.1
# */
# StoredInformationType::= BIT STRING {
#     undefined       (0),
#     staticDb	    (1),    
#     dynamicDb   	(2),
#     realTimeDb  	(3),
#     map		    	(4)	
# } (SIZE (8,... )) 
# ------------------------------------------------------------------------------

uint8[] value
uint8 bits_unused
uint8 SIZE_BITS = 8
uint8 BIT_INDEX_UNDEFINED = 0
uint8 BIT_INDEX_STATIC_DB = 1
uint8 BIT_INDEX_DYNAMIC_DB = 2
uint8 BIT_INDEX_REAL_TIME_DB = 3
uint8 BIT_INDEX_MAP = 4


================================================================================
MSG: etsi_its_denm_ts_msgs/ConfidenceLevel
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents a confidence level in percentage.
#  * 
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 101`) : for the confidence level in %,
#  * - `101`                   : in case the confidence level is not available.
#  *
#  * @unit Percent 
#  * @category: Basic information 
#  * @revision: Created in V2.1.1 
# */
# ConfidenceLevel ::= INTEGER {
#     unavailable (101)  
# } (1..101)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 101
uint8 UNAVAILABLE = 101


================================================================================
MSG: etsi_its_denm_ts_msgs/OccupiedLanesWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a set of lanes which are partially or fully occupied by an object or event at an externally defined reference position. 
#  *
#  * @note: In contrast to @ref GeneralizedLanePosition, the dimension of the object or event area (width and length) is taken into account to determine the occupancy, 
#  * i.e. this DF describes the lanes which are blocked by an object or event and not the position of the object / event itself. A confidence is used to describe the 
#  * probability that exactly all the provided lanes are occupied. 
#  *
#  * It shall include the following components: 
#  *
#  * @field lanePositionBased: a set of up to `4` lanes that are partially or fully occupied by an object or event, ordered by increasing value of @ref LanePosition. 
#  * Lanes that are partially occupied can be described using the component lanePositionWithLateralDetails of @ref  Options, with the following constraints: 
#  * The distance to lane borders which are covered by the object / event shall be set to 0. Only the distances to the leftmost and/or rightmost border which are not covered by 
#  * the object / event shall be provided with values > 0. Those values shall be added to the respective instances of @ref LanePositionOptions, i.e. the first entry shall contain the component distanceToLeftBorder > 0 , 
#  * and/or the last entry shall contain the component distanceToRightBorder > 0; the respective other components of these entries shall be set to 0.
#  * 
#  * @field mapBased: optional lane information described in the context of a MAPEM as specified in ETSI TS 103 301 [15]. 
#  * If present, it shall describe the same lane(s) as listed in the component lanePositionBased, but using the lane identification of the MAPEM. This component can be used only if a 
#  * MAPEM is available for the reference position (e.g. on an intersection): In this case it is used as a synonym to the mandatory component lanePositionBased. 
#  *
#  * @field confidence: mandatory confidence information for expressing the probability that all the provided lanes are occupied. It also provides information on how the lane 
#  * information were generated. If none of the sensors were used, the lane information is assumed to be derived directly from the absolute reference position and the related dimension.
#  *
#  * @category: Road Topology information
#  * @revision: Created in V2.2.1
#  */
# OccupiedLanesWithConfidence::= SEQUENCE {
#     lanePositionBased     SEQUENCE (SIZE(1..4)) OF LanePositionOptions,
#     mapBased              SEQUENCE (SIZE(1..4)) OF MapPosition  OPTIONAL,
#     confidence            MetaInformation,
#     ... 
# }
# ------------------------------------------------------------------------------

LanePositionOptions[] lane_position_based
uint8 LANE_POSITION_BASED_MIN_SIZE = 1
uint8 LANE_POSITION_BASED_MAX_SIZE = 4

MapPosition[] map_based
bool map_based_is_present
uint8 MAP_BASED_MIN_SIZE = 1
uint8 MAP_BASED_MAX_SIZE = 4

MetaInformation confidence


================================================================================
MSG: etsi_its_denm_ts_msgs/IvimReferences
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF shall contain a list of @ref IvimReference.
#  *
#  * @category: Communication information
#  * @revision: Created in V2.2.1
# */
# IvimReferences::= SEQUENCE (SIZE(1..8,...)) OF IvimReference
# ------------------------------------------------------------------------------

IvimReference[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 8


================================================================================
MSG: etsi_its_denm_ts_msgs/IvimReference
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF provides the reference to the information contained in a IVIM according to ETSI TS 103 301 [15]. 
#  *
#  * It shall include the following components: 
#  * 
#  * @field serviceProviderId: identifier of the organization that provided the IVIM.
#  *
#  * @field iviIdentificationNumber: identifier of the IVIM, as assigned by the organization identified in serviceProviderId.
#  *
#  * @category: Communication information
#  * @revision: Created in V2.2.1
#  */
# IvimReference::= SEQUENCE {
#     serviceProviderId         Provider, 
#     iviIdentificationNumber   IviIdentificationNumber
# }
# ------------------------------------------------------------------------------

Provider service_provider_id

IviIdentificationNumber ivi_identification_number


================================================================================
MSG: etsi_its_denm_ts_msgs/Provider
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF identifies an organization.
#  *
#  * It shall include the following components: 
#  * 
#  * @field countryCode: represents the country code that identifies the country of the national registration administrator for issuers according to ISO 14816.
#  *
#  * @field providerIdentifier: identifies the organization according to the national ISO 14816 register for issuers.
#  *
#  * @note: See https://www.itsstandards.eu/registries/register-of-nra-i-cs1/ for a list of national registration administrators and their respective registers
#  * 
#  * @category: Communication information
#  * @revision: Created in V2.2.1 based on ISO 17573-3 [24]
#  */
# Provider ::= SEQUENCE {
# 	countryCode		CountryCode,
# 	providerIdentifier	IssuerIdentifier
# } 
# ------------------------------------------------------------------------------

CountryCode country_code

IssuerIdentifier provider_identifier


================================================================================
MSG: etsi_its_denm_ts_msgs/CountryCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents an ISO 3166-1 [25] country code encoded using ITA-2 encoding.
#  *
#  * @category: Basic information
#  * @revision: Created in V2.2.1 based on ISO 14816 [23]
# */
# CountryCode ::= BIT STRING(SIZE(10))
# ------------------------------------------------------------------------------

uint8[] value
uint8 bits_unused
uint8 SIZE_BITS = 10


================================================================================
MSG: etsi_its_denm_ts_msgs/IssuerIdentifier
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represent the identifier of an organization according to the applicable registry.
#  *
#  * @category: Basic information
#  * @revision: Created in V2.2.1 based on ISO 14816 [23]
# */
# IssuerIdentifier ::= INTEGER(0 .. 16383)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 16383


================================================================================
MSG: etsi_its_denm_ts_msgs/IviIdentificationNumber
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents the identifier of the IVIM.
#  *
#  * @category: Basic information
#  * @revision: Created in V2.2.1 based on ETSI TS 103 301 [15]
# */
# IviIdentificationNumber::= INTEGER(1..32767,..., 8388607) 
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 1
uint16 MAX = 32767


================================================================================
MSG: etsi_its_denm_ts_msgs/MapReferences
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF shall contain a list of @ref MapReference.
#  *
#  * @category: Road topology information
#  * @revision: Created in V2.2.1
# */
# MapReferences::= SEQUENCE (SIZE(1..8,...)) OF MapReference
# ------------------------------------------------------------------------------

MapReference[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 8


================================================================================
MSG: etsi_its_denm_ts_msgs/TracesExtended
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents one or more paths using @ref PathExtended.
#  * 
#  * @category: GeoReference information
#  * @revision: Created in V2.2.1
#  */
# TracesExtended ::= SEQUENCE SIZE(1..7) OF PathExtended
# ------------------------------------------------------------------------------

PathExtended[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 7


================================================================================
MSG: etsi_its_denm_ts_msgs/PathExtended
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF represents a path towards a specific point specified in the @ref EventZone.
#  *
#  * It shall include the following components: 
#  * 
#  * @field pointOfEventZone: the ordinal number of the point within the DF EventZone, i.e. within the list of EventPoints.
#  *
#  * @field path: the associated path towards the point specified in pointOfEventZone.
#  * The first PathPoint presents an offset delta position with regards to the position of that pointOfEventZone.
#  *
#  * @category: GeoReference information
#  * @revision: Created in V2.2.1
# */
# PathExtended::= SEQUENCE {
#   pointOfEventZone    INTEGER(1..23),
#   path                Path
# }
# ------------------------------------------------------------------------------

uint8 point_of_event_zone
uint8 POINT_OF_EVENT_ZONE_MIN = 1
uint8 POINT_OF_EVENT_ZONE_MAX = 23

Path path


================================================================================
MSG: etsi_its_denm_ts_msgs/PathPredictedList
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents one or more predicted paths, or trajectories or path zones (zones that include all possible paths/trajectories within its boundaries) using @ref PathPredicted2.
#  * It shall contain up to `16` @ref PathPredicted2. 
#  * 
#  * @category: GeoReference information
#  * @revision: V2.2.1
#  */
# PathPredictedList ::= SEQUENCE SIZE(1..16,...) OF PathPredicted2
# ------------------------------------------------------------------------------

PathPredicted2[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 16


================================================================================
MSG: etsi_its_denm_ts_msgs/PathPredicted2
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF represents a predicted path, predicted trajectory or predicted path zone together with usage information and a prediction confidence.
#  *
#  * It shall include the following components: 
#  *
#  * @field pathPredicted: the predicted path (pathDeltaTime ABSENT) or trajectory (pathDeltaTime PRESENT) and/or the path zone (symmetricAreaOffset PRESENT).
#  *
#  * @field usageIndication: an indication of how the predicted path will be used. 
#  *
#  * @field confidenceLevel: the confidence that the path/trajectory in pathPredicted will occur as predicted.
#  *
#  * @category: GeoReference information
#  * @revision: created in V2.2.1
#  */
# PathPredicted2::= SEQUENCE{
#     pathPredicted     PathPredicted
#    ((WITH COMPONENT (WITH COMPONENTS {..., pathDeltaTime ABSENT, symmetricAreaOffset ABSENT})) |
#     (WITH COMPONENT (WITH COMPONENTS {..., pathDeltaTime PRESENT, symmetricAreaOffset ABSENT})) |
#     (WITH COMPONENT (WITH COMPONENTS {..., pathDeltaTime ABSENT, symmetricAreaOffset PRESENT})) |
#     (WITH COMPONENT (WITH COMPONENTS {..., pathDeltaTime PRESENT, symmetricAreaOffset PRESENT}))),
#     usageIndication   UsageIndication,
#     confidenceLevel   ConfidenceLevel,   
#     ...
# }
# ------------------------------------------------------------------------------

PathPredicted path_predicted

UsageIndication usage_indication

ConfidenceLevel confidence_level


================================================================================
MSG: etsi_its_denm_ts_msgs/PathPredicted
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a predicted path or trajectory with a set of predicted points and optional information to generate a shape which is estimated to contain the real path. 
#  * It shall contain up to `16` @ref PathPointPredicted. 
#  * 
#  * The first PathPoint presents an offset delta position with regards to an external reference position.
#  * Each other PathPoint presents an offset delta position and optionally an offset travel time with regards to the previous PathPoint. 
#  *
#  * @category: GeoReference information
#  * @revision: created in V2.1.1 , size constraint changed to SIZE(1..16, ...) in V2.2.1
#  */
# PathPredicted::= SEQUENCE (SIZE(1..16,...)) OF PathPointPredicted
# ------------------------------------------------------------------------------

PathPointPredicted[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 16


================================================================================
MSG: etsi_its_denm_ts_msgs/PathPointPredicted
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF defines a predicted offset position that can be used within a predicted path or trajectory, together with optional data to describe a path zone shape.
#  *
#  * It shall include the following components: 
#  *
#  * @field deltaLatitude: the offset latitude with regards to a pre-defined reference position. 
#  *
#  * @field deltaLongitude: the offset longitude with regards to a pre-defined reference position. 
#  * 
#  * @field horizontalPositionConfidence: the optional confidence value associated to the horizontal geographical position.
#  *
#  * @field deltaAltitude: the optional offset altitude with regards to a pre-defined reference position, with default value unavailable. 
#  *
#  * @field altitudeConfidence: the optional confidence value associated to the altitude value of the geographical position, with default value unavailable.
#  * 
#  * @field pathDeltaTime: the optional travel time to the waypoint from the predefined reference position.
# 
#  * @field symmetricAreaOffset: the optional symmetric offset to generate a shape, see Annex D for details.
#  *  
#  * @field asymmetricAreaOffset: the optional asymmetric offset to generate a shape, see Annex D for details. 
#  *
#  * @category GeoReference information
#  * @revision: Created in V2.1.1, type of pathDeltaTime changed and optionality added, fields symmetricAreaOffset and asymmetricAreaOffset added in V2.2.1
#  */
# PathPointPredicted::= SEQUENCE {
#   deltaLatitude                 DeltaLatitude,      
#   deltaLongitude                DeltaLongitude, 
#   horizontalPositionConfidence  PosConfidenceEllipse OPTIONAL,   
#   deltaAltitude                 DeltaAltitude DEFAULT unavailable, 
#   altitudeConfidence            AltitudeConfidence DEFAULT unavailable,
#   pathDeltaTime                 PathDeltaTimeChoice OPTIONAL,
#   symmetricAreaOffset           StandardLength9b OPTIONAL, 
#   asymmetricAreaOffset          StandardLength9b OPTIONAL, 
#   ... 
# }
# ------------------------------------------------------------------------------

DeltaLatitude delta_latitude

DeltaLongitude delta_longitude

PosConfidenceEllipse horizontal_position_confidence
bool horizontal_position_confidence_is_present

DeltaAltitude delta_altitude
uint16 DELTA_ALTITUDE_DEFAULT = 12800

AltitudeConfidence altitude_confidence
uint8 ALTITUDE_CONFIDENCE_DEFAULT = 15

PathDeltaTimeChoice path_delta_time
bool path_delta_time_is_present

StandardLength9b symmetric_area_offset
bool symmetric_area_offset_is_present

StandardLength9b asymmetric_area_offset
bool asymmetric_area_offset_is_present


================================================================================
MSG: etsi_its_denm_ts_msgs/PosConfidenceEllipse
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF indicates the horizontal position confidence ellipse which represents the estimated accuracy with a 
#  * confidence level of 95  %. The centre of the ellipse shape corresponds to the reference
#  * position point for which the position accuracy is evaluated.
#  *
#  * It shall include the following components: 
#  *
#  * @field semiMajorConfidence: half of length of the major axis, i.e. distance between the centre point
#  * and major axis point of the position accuracy ellipse. 
#  *
#  * @field semiMinorConfidence: half of length of the minor axis, i.e. distance between the centre point
#  * and minor axis point of the position accuracy ellipse. 
#  *
#  * @field semiMajorOrientation: orientation direction of the ellipse major axis of the position accuracy
#  * ellipse with regards to the WGS84 north. 
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  *
#  *
#  * @category GeoReference information
#  * @revision: V1.3.1
#  */
# PosConfidenceEllipse ::= SEQUENCE {
#     semiMajorConfidence     SemiAxisLength,
#     semiMinorConfidence     SemiAxisLength,
#     semiMajorOrientation    HeadingValue
# }
# ------------------------------------------------------------------------------

SemiAxisLength semi_major_confidence

SemiAxisLength semi_minor_confidence

HeadingValue semi_major_orientation


================================================================================
MSG: etsi_its_denm_ts_msgs/SemiAxisLength
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the horizontal position confidence value which represents the estimated absolute position accuracy, in one of the axis direction as defined in a shape of ellipse with a 
#  * confidence level of 95 %. 
#  * 
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 4 094`) if the accuracy is equal to or less than n * 0,01 metre,
#  * - `4 094` if the accuracy is out of range, i.e. greater than 4,093 m,
#  * - `4 095` if the accuracy information is unavailable.
#  *
#  * The value 0 shall not be used.
#  * 
#  * @note: The fact that a position coordinate value is received with confidence value set to `unavailable(4095)`.
#  * can be caused by several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the position coordinate value may be valid and used by the application.
#  * If a position coordinate value is received and its confidence value is set to `outOfRange(4094)`, it means that
#  * the position coordinate value is not valid and therefore cannot be trusted. Such value is not useful
#  * for the application.
# 
#  * @unit 0,01 metre 
#  * @category: GeoReference Information
#  * @revision: Description revised in V2.1.1
#  */
# SemiAxisLength ::= INTEGER{
#     doNotUse    (0),
#     outOfRange  (4094), 
#     unavailable (4095)
# } (0..4095)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 4095
uint16 DO_NOT_USE = 0
uint16 OUT_OF_RANGE = 4094
uint16 UNAVAILABLE = 4095


================================================================================
MSG: etsi_its_denm_ts_msgs/HeadingValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the orientation of the horizontal velocity vector with regards to the WGS84 north.
#  * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.
#  *
#  * @note: this DE is kept for backwards compatibility reasons only. It is recommended to use the @ref Wgs84AngleValue instead. 
#  *
#  * Unit: 0,1 degree
#  * Categories: GeoReference information
#  * @revision: Description revised in V2.1.1 (usage of value 3600 specified) 
# */
# HeadingValue ::= INTEGER { 
#     wgs84North  (0),
#     wgs84East   (900),
#     wgs84South  (1800),
#     wgs84West   (2700),
#     doNotUse    (3600),
#     unavailable (3601)
# } (0..3601)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 WGS84_NORTH = 0
uint16 WGS84_EAST = 900
uint16 WGS84_SOUTH = 1800
uint16 WGS84_WEST = 2700
uint16 DO_NOT_USE = 3600
uint16 UNAVAILABLE = 3601


================================================================================
MSG: etsi_its_denm_ts_msgs/AltitudeConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the altitude confidence value which represents the estimated absolute accuracy of an altitude value of a geographical point with a default confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  *
#  * The value shall be set to: 
#  *   - 0  - `alt-000-01`   - if the confidence value is equal to or less than 0,01 metre,
#  *   - 1  - `alt-000-02`   - if the confidence value is equal to or less than 0,02 metre and greater than 0,01 metre,
#  *   - 2  - `alt-000-05`   - if the confidence value is equal to or less than 0,05 metre and greater than 0,02 metre,            
#  *   - 3  - `alt-000-10`   - if the confidence value is equal to or less than 0,1 metre and greater than 0,05 metre,            
#  *   - 4  - `alt-000-20`   - if the confidence value is equal to or less than 0,2 metre and greater than 0,1 metre,            
#  *   - 5  - `alt-000-50`   - if the confidence value is equal to or less than 0,5 metre and greater than 0,2 metre,             
#  *   - 6  - `alt-001-00`   - if the confidence value is equal to or less than 1 metre and greater than 0,5 metre,             
#  *   - 7  - `alt-002-00`   - if the confidence value is equal to or less than 2 metres and greater than 1 metre,             
#  *   - 8  - `alt-005-00`   - if the confidence value is equal to or less than 5 metres and greater than 2 metres,              
#  *   - 9  - `alt-010-00`   - if the confidence value is equal to or less than 10 metres and greater than 5 metres,             
#  *   - 10 - `alt-020-00`   - if the confidence value is equal to or less than 20 metres and greater than 10 metres,            
#  *   - 11 - `alt-050-00`   - if the confidence value is equal to or less than 50 metres and greater than 20 metres,            
#  *   - 12 - `alt-100-00`   - if the confidence value is equal to or less than 100 metres and greater than 50 metres,           
#  *   - 13 - `alt-200-00`   - if the confidence value is equal to or less than 200 metres and greater than 100 metres,           
#  *   - 14 - `outOfRange`   - if the confidence value is out of range, i.e. greater than 200 metres,
#  *   - 15 - `unavailable`  - if the confidence value is unavailable.       
#  *
#  * @note: The fact that an altitude value is received with confidence value set to `unavailable(15)` can be caused
#  * by several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the altitude value may be valid and used by the application.
#  * 
#  * @note: If an altitude value is received and its confidence value is set to `outOfRange(14)`, it means that the  
#  * altitude value is not valid and therefore cannot be trusted. Such value is not useful for the application.             
#  *
#  * @category: GeoReference information
#  * @revision: Description revised in V2.1.1
#  */
# AltitudeConfidence ::= ENUMERATED {
#     alt-000-01  (0),
#     alt-000-02  (1),
#     alt-000-05  (2),
#     alt-000-10  (3),
#     alt-000-20  (4),
#     alt-000-50  (5),
#     alt-001-00  (6),
#     alt-002-00  (7),
#     alt-005-00  (8),
#     alt-010-00  (9),
#     alt-020-00  (10),
#     alt-050-00  (11),
#     alt-100-00  (12),
#     alt-200-00  (13),
#     outOfRange  (14),
#     unavailable (15)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 ALT_000_01 = 0
uint8 ALT_000_02 = 1
uint8 ALT_000_05 = 2
uint8 ALT_000_10 = 3
uint8 ALT_000_20 = 4
uint8 ALT_000_50 = 5
uint8 ALT_001_00 = 6
uint8 ALT_002_00 = 7
uint8 ALT_005_00 = 8
uint8 ALT_010_00 = 9
uint8 ALT_020_00 = 10
uint8 ALT_050_00 = 11
uint8 ALT_100_00 = 12
uint8 ALT_200_00 = 13
uint8 OUT_OF_RANGE = 14
uint8 UNAVAILABLE = 15


================================================================================
MSG: etsi_its_denm_ts_msgs/PathDeltaTimeChoice
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents estimated/predicted travel time between a position and a predefined reference position. 
#  *
#  * the following options are available:
#  * 
#  * @field deltaTimeHighPrecision: delta time with precision of 0,1 s.
#  *
#  * @field deltaTimeBigRange: delta time with precision of 10 s.
#  *
#  * @category: Basic information
#  * @revision: Created in V2.2.1
#  */
# PathDeltaTimeChoice::= CHOICE {
#     deltaTimeHighPrecision	DeltaTimeTenthOfSecond,
#     deltaTimeBigRange	    DeltaTimeTenSeconds,
#     ...
# }
# ------------------------------------------------------------------------------

uint8 choice

DeltaTimeTenthOfSecond delta_time_high_precision
uint8 CHOICE_DELTA_TIME_HIGH_PRECISION = 0

DeltaTimeTenSeconds delta_time_big_range
uint8 CHOICE_DELTA_TIME_BIG_RANGE = 1


================================================================================
MSG: etsi_its_denm_ts_msgs/DeltaTimeTenthOfSecond
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents a difference in time with respect to a reference time.
#  *
#  * The value shall be set to:
#  * - `0` for a difference in time of 0 seconds. 
#  * - `n` (`n > 0` and `n < 128`) to indicate a time value equal to or less than n x 0,1 s, and greater than (n-1) x 0,1 s,
#  *
#  * @unit: 0,1 s
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# DeltaTimeTenthOfSecond::= INTEGER {
#     unavailable (127)  
# } (0..127) 
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 127
uint8 UNAVAILABLE = 127


================================================================================
MSG: etsi_its_denm_ts_msgs/DeltaTimeTenSeconds
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents a difference in time with respect to a reference time.
#  *
#  * The value shall be set to:
#  * - `-0` for a difference in time of 0 seconds. 
#  * - `n` (`n > 0` and `n < 128`) to indicate a time value equal to or less than n x 10 s, and greater than (n-1) x 10 s,
#  *
#  * @unit: 10 s
#  * @category: Basic information
#  * @revision: Created in V2.2.1
# */
# DeltaTimeTenSeconds ::= INTEGER  (0..127)  
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 127


================================================================================
MSG: etsi_its_denm_ts_msgs/UsageIndication
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
#   -t
#   denm_ts
#   -o
#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents indication of how a certain path or area will be used. 
#  * 
#  * The value shall be set to:
#  * - 0  - ` noIndication `     - in case it will remain free to be used,
#  * - 1  - ` specialUse `       - in case it will be physically blocked by special use,
#  * - 2  - ` rescueOperation`   - in case it is intended to be used for rescue operations,
#  *
#  * @category: Basic information
#  * @revision: Created in V2.2.1
#  */
# UsageIndication ::= ENUMERATED { 
#     noIndication(0),
#     specialUse (1),
#     rescueOperation (2),
#     ...
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 NO_INDICATION = 0
uint8 SPECIAL_USE = 1
uint8 RESCUE_OPERATION = 2

"""
  __slots__ = ['event_speed','event_speed_is_present','event_position_heading','event_position_heading_is_present','detection_zones_to_event_position','road_type','road_type_is_present','lane_positions','lane_positions_is_present','occupied_lanes','occupied_lanes_is_present','linked_ivims','linked_ivims_is_present','linked_mapems','linked_mapems_is_present','detection_zones_to_specified_event_point','detection_zones_to_specified_event_point_is_present','predicted_paths','predicted_paths_is_present']
  _slot_types = ['etsi_its_denm_ts_msgs/Speed','bool','etsi_its_denm_ts_msgs/Wgs84Angle','bool','etsi_its_denm_ts_msgs/Traces','etsi_its_denm_ts_msgs/RoadType','bool','etsi_its_denm_ts_msgs/GeneralizedLanePositions','bool','etsi_its_denm_ts_msgs/OccupiedLanesWithConfidence','bool','etsi_its_denm_ts_msgs/IvimReferences','bool','etsi_its_denm_ts_msgs/MapReferences','bool','etsi_its_denm_ts_msgs/TracesExtended','bool','etsi_its_denm_ts_msgs/PathPredictedList','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       event_speed,event_speed_is_present,event_position_heading,event_position_heading_is_present,detection_zones_to_event_position,road_type,road_type_is_present,lane_positions,lane_positions_is_present,occupied_lanes,occupied_lanes_is_present,linked_ivims,linked_ivims_is_present,linked_mapems,linked_mapems_is_present,detection_zones_to_specified_event_point,detection_zones_to_specified_event_point_is_present,predicted_paths,predicted_paths_is_present

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(LocationContainer, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.event_speed is None:
        self.event_speed = etsi_its_denm_ts_msgs.msg.Speed()
      if self.event_speed_is_present is None:
        self.event_speed_is_present = False
      if self.event_position_heading is None:
        self.event_position_heading = etsi_its_denm_ts_msgs.msg.Wgs84Angle()
      if self.event_position_heading_is_present is None:
        self.event_position_heading_is_present = False
      if self.detection_zones_to_event_position is None:
        self.detection_zones_to_event_position = etsi_its_denm_ts_msgs.msg.Traces()
      if self.road_type is None:
        self.road_type = etsi_its_denm_ts_msgs.msg.RoadType()
      if self.road_type_is_present is None:
        self.road_type_is_present = False
      if self.lane_positions is None:
        self.lane_positions = etsi_its_denm_ts_msgs.msg.GeneralizedLanePositions()
      if self.lane_positions_is_present is None:
        self.lane_positions_is_present = False
      if self.occupied_lanes is None:
        self.occupied_lanes = etsi_its_denm_ts_msgs.msg.OccupiedLanesWithConfidence()
      if self.occupied_lanes_is_present is None:
        self.occupied_lanes_is_present = False
      if self.linked_ivims is None:
        self.linked_ivims = etsi_its_denm_ts_msgs.msg.IvimReferences()
      if self.linked_ivims_is_present is None:
        self.linked_ivims_is_present = False
      if self.linked_mapems is None:
        self.linked_mapems = etsi_its_denm_ts_msgs.msg.MapReferences()
      if self.linked_mapems_is_present is None:
        self.linked_mapems_is_present = False
      if self.detection_zones_to_specified_event_point is None:
        self.detection_zones_to_specified_event_point = etsi_its_denm_ts_msgs.msg.TracesExtended()
      if self.detection_zones_to_specified_event_point_is_present is None:
        self.detection_zones_to_specified_event_point_is_present = False
      if self.predicted_paths is None:
        self.predicted_paths = etsi_its_denm_ts_msgs.msg.PathPredictedList()
      if self.predicted_paths_is_present is None:
        self.predicted_paths_is_present = False
    else:
      self.event_speed = etsi_its_denm_ts_msgs.msg.Speed()
      self.event_speed_is_present = False
      self.event_position_heading = etsi_its_denm_ts_msgs.msg.Wgs84Angle()
      self.event_position_heading_is_present = False
      self.detection_zones_to_event_position = etsi_its_denm_ts_msgs.msg.Traces()
      self.road_type = etsi_its_denm_ts_msgs.msg.RoadType()
      self.road_type_is_present = False
      self.lane_positions = etsi_its_denm_ts_msgs.msg.GeneralizedLanePositions()
      self.lane_positions_is_present = False
      self.occupied_lanes = etsi_its_denm_ts_msgs.msg.OccupiedLanesWithConfidence()
      self.occupied_lanes_is_present = False
      self.linked_ivims = etsi_its_denm_ts_msgs.msg.IvimReferences()
      self.linked_ivims_is_present = False
      self.linked_mapems = etsi_its_denm_ts_msgs.msg.MapReferences()
      self.linked_mapems_is_present = False
      self.detection_zones_to_specified_event_point = etsi_its_denm_ts_msgs.msg.TracesExtended()
      self.detection_zones_to_specified_event_point_is_present = False
      self.predicted_paths = etsi_its_denm_ts_msgs.msg.PathPredictedList()
      self.predicted_paths_is_present = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_H2BH2B().pack(_x.event_speed.speed_value.value, _x.event_speed.speed_confidence.value, _x.event_speed_is_present, _x.event_position_heading.value.value, _x.event_position_heading.confidence.value, _x.event_position_heading_is_present))
      length = len(self.detection_zones_to_event_position.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.detection_zones_to_event_position.array:
        length = len(val1.array)
        buff.write(_struct_I.pack(length))
        for val2 in val1.array:
          _v1 = val2.path_position
          _v2 = _v1.delta_latitude
          _x = _v2.value
          buff.write(_get_struct_i().pack(_x))
          _v3 = _v1.delta_longitude
          _x = _v3.value
          buff.write(_get_struct_i().pack(_x))
          _v4 = _v1.delta_altitude
          _x = _v4.value
          buff.write(_get_struct_h().pack(_x))
          _v5 = val2.path_delta_time
          _x = _v5.value
          buff.write(_get_struct_H().pack(_x))
          _x = val2.path_delta_time_is_present
          buff.write(_get_struct_B().pack(_x))
      _x = self
      buff.write(_get_struct_2B().pack(_x.road_type.value, _x.road_type_is_present))
      length = len(self.lane_positions.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.lane_positions.array:
        _v6 = val1.lane_position_based
        _x = _v6.choice
        buff.write(_get_struct_B().pack(_x))
        _v7 = _v6.simplelane_position
        _x = _v7.value
        buff.write(_get_struct_b().pack(_x))
        _v8 = _v6.simple_lane_type
        _x = _v8.value
        buff.write(_get_struct_B().pack(_x))
        _v9 = _v6.detailedlane_position
        _v10 = _v9.transversal_position
        _x = _v10.value
        buff.write(_get_struct_b().pack(_x))
        _v11 = _v9.lane_type
        _x = _v11.value
        buff.write(_get_struct_B().pack(_x))
        _v12 = _v9.direction
        _x = _v12.value
        buff.write(_get_struct_B().pack(_x))
        _v13 = _v6.lane_position_with_lateral_details
        _v14 = _v13.transversal_position
        _x = _v14.value
        buff.write(_get_struct_b().pack(_x))
        _v15 = _v13.lane_type
        _x = _v15.value
        buff.write(_get_struct_B().pack(_x))
        _v16 = _v13.direction
        _x = _v16.value
        buff.write(_get_struct_B().pack(_x))
        _v17 = _v13.distance_to_left_border
        _x = _v17.value
        buff.write(_get_struct_H().pack(_x))
        _v18 = _v13.distance_to_right_border
        _x = _v18.value
        buff.write(_get_struct_H().pack(_x))
        _v19 = _v6.traffic_island_position
        _v20 = _v19.one_side
        _v21 = _v20.transversal_position
        _x = _v21.value
        buff.write(_get_struct_b().pack(_x))
        _v22 = _v20.lane_type
        _x = _v22.value
        buff.write(_get_struct_B().pack(_x))
        _v23 = _v20.direction
        _x = _v23.value
        buff.write(_get_struct_B().pack(_x))
        _v24 = _v19.other_side
        _v25 = _v24.transversal_position
        _x = _v25.value
        buff.write(_get_struct_b().pack(_x))
        _v26 = _v24.lane_type
        _x = _v26.value
        buff.write(_get_struct_B().pack(_x))
        _v27 = _v24.direction
        _x = _v27.value
        buff.write(_get_struct_B().pack(_x))
        _v28 = val1.map_based
        _v29 = _v28.map_reference
        _x = _v29.choice
        buff.write(_get_struct_B().pack(_x))
        _v30 = _v29.roadsegment
        _v31 = _v30.region
        _x = _v31.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v30.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v32 = _v30.id
        _x = _v32.value
        buff.write(_get_struct_H().pack(_x))
        _v33 = _v29.intersection
        _v34 = _v33.region
        _x = _v34.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v33.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v35 = _v33.id
        _x = _v35.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v28.map_reference_is_present
        buff.write(_get_struct_B().pack(_x))
        _v36 = _v28.lane_id
        _x = _v36.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v28.lane_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v37 = _v28.connection_id
        _x = _v37.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v28.connection_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v38 = _v28.longitudinal_lane_position
        _v39 = _v38.longitudinal_lane_position_value
        _x = _v39.value
        buff.write(_get_struct_H().pack(_x))
        _v40 = _v38.longitudinal_lane_position_confidence
        _x = _v40.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v28.longitudinal_lane_position_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = val1.map_based_is_present
        buff.write(_get_struct_B().pack(_x))
        _v41 = val1.confidence
        _v42 = _v41.used_detection_information
        _x = _v42.value
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v42.bits_unused
        buff.write(_get_struct_B().pack(_x))
        _v43 = _v41.used_stored_information
        _x = _v43.value
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v43.bits_unused
        buff.write(_get_struct_B().pack(_x))
        _v44 = _v41.confidence_value
        _x = _v44.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v41.confidence_value_is_present
        buff.write(_get_struct_B().pack(_x))
      _x = self.lane_positions_is_present
      buff.write(_get_struct_B().pack(_x))
      length = len(self.occupied_lanes.lane_position_based)
      buff.write(_struct_I.pack(length))
      for val1 in self.occupied_lanes.lane_position_based:
        _x = val1.choice
        buff.write(_get_struct_B().pack(_x))
        _v45 = val1.simplelane_position
        _x = _v45.value
        buff.write(_get_struct_b().pack(_x))
        _v46 = val1.simple_lane_type
        _x = _v46.value
        buff.write(_get_struct_B().pack(_x))
        _v47 = val1.detailedlane_position
        _v48 = _v47.transversal_position
        _x = _v48.value
        buff.write(_get_struct_b().pack(_x))
        _v49 = _v47.lane_type
        _x = _v49.value
        buff.write(_get_struct_B().pack(_x))
        _v50 = _v47.direction
        _x = _v50.value
        buff.write(_get_struct_B().pack(_x))
        _v51 = val1.lane_position_with_lateral_details
        _v52 = _v51.transversal_position
        _x = _v52.value
        buff.write(_get_struct_b().pack(_x))
        _v53 = _v51.lane_type
        _x = _v53.value
        buff.write(_get_struct_B().pack(_x))
        _v54 = _v51.direction
        _x = _v54.value
        buff.write(_get_struct_B().pack(_x))
        _v55 = _v51.distance_to_left_border
        _x = _v55.value
        buff.write(_get_struct_H().pack(_x))
        _v56 = _v51.distance_to_right_border
        _x = _v56.value
        buff.write(_get_struct_H().pack(_x))
        _v57 = val1.traffic_island_position
        _v58 = _v57.one_side
        _v59 = _v58.transversal_position
        _x = _v59.value
        buff.write(_get_struct_b().pack(_x))
        _v60 = _v58.lane_type
        _x = _v60.value
        buff.write(_get_struct_B().pack(_x))
        _v61 = _v58.direction
        _x = _v61.value
        buff.write(_get_struct_B().pack(_x))
        _v62 = _v57.other_side
        _v63 = _v62.transversal_position
        _x = _v63.value
        buff.write(_get_struct_b().pack(_x))
        _v64 = _v62.lane_type
        _x = _v64.value
        buff.write(_get_struct_B().pack(_x))
        _v65 = _v62.direction
        _x = _v65.value
        buff.write(_get_struct_B().pack(_x))
      length = len(self.occupied_lanes.map_based)
      buff.write(_struct_I.pack(length))
      for val1 in self.occupied_lanes.map_based:
        _v66 = val1.map_reference
        _x = _v66.choice
        buff.write(_get_struct_B().pack(_x))
        _v67 = _v66.roadsegment
        _v68 = _v67.region
        _x = _v68.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v67.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v69 = _v67.id
        _x = _v69.value
        buff.write(_get_struct_H().pack(_x))
        _v70 = _v66.intersection
        _v71 = _v70.region
        _x = _v71.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v70.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v72 = _v70.id
        _x = _v72.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.map_reference_is_present
        buff.write(_get_struct_B().pack(_x))
        _v73 = val1.lane_id
        _x = _v73.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.lane_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v74 = val1.connection_id
        _x = _v74.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.connection_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v75 = val1.longitudinal_lane_position
        _v76 = _v75.longitudinal_lane_position_value
        _x = _v76.value
        buff.write(_get_struct_H().pack(_x))
        _v77 = _v75.longitudinal_lane_position_confidence
        _x = _v77.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.longitudinal_lane_position_is_present
        buff.write(_get_struct_B().pack(_x))
      _x = self.occupied_lanes.map_based_is_present
      buff.write(_get_struct_B().pack(_x))
      _x = self.occupied_lanes.confidence.used_detection_information.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.occupied_lanes.confidence.used_detection_information.bits_unused
      buff.write(_get_struct_B().pack(_x))
      _x = self.occupied_lanes.confidence.used_stored_information.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_4B().pack(_x.occupied_lanes.confidence.used_stored_information.bits_unused, _x.occupied_lanes.confidence.confidence_value.value, _x.occupied_lanes.confidence.confidence_value_is_present, _x.occupied_lanes_is_present))
      length = len(self.linked_ivims.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.linked_ivims.array:
        _v78 = val1.service_provider_id
        _v79 = _v78.country_code
        _x = _v79.value
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v79.bits_unused
        buff.write(_get_struct_B().pack(_x))
        _v80 = _v78.provider_identifier
        _x = _v80.value
        buff.write(_get_struct_H().pack(_x))
        _v81 = val1.ivi_identification_number
        _x = _v81.value
        buff.write(_get_struct_H().pack(_x))
      _x = self.linked_ivims_is_present
      buff.write(_get_struct_B().pack(_x))
      length = len(self.linked_mapems.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.linked_mapems.array:
        _x = val1.choice
        buff.write(_get_struct_B().pack(_x))
        _v82 = val1.roadsegment
        _v83 = _v82.region
        _x = _v83.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v82.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v84 = _v82.id
        _x = _v84.value
        buff.write(_get_struct_H().pack(_x))
        _v85 = val1.intersection
        _v86 = _v85.region
        _x = _v86.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v85.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v87 = _v85.id
        _x = _v87.value
        buff.write(_get_struct_H().pack(_x))
      _x = self.linked_mapems_is_present
      buff.write(_get_struct_B().pack(_x))
      length = len(self.detection_zones_to_specified_event_point.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.detection_zones_to_specified_event_point.array:
        _x = val1.point_of_event_zone
        buff.write(_get_struct_B().pack(_x))
        _v88 = val1.path
        length = len(_v88.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v88.array:
          _v89 = val3.path_position
          _v90 = _v89.delta_latitude
          _x = _v90.value
          buff.write(_get_struct_i().pack(_x))
          _v91 = _v89.delta_longitude
          _x = _v91.value
          buff.write(_get_struct_i().pack(_x))
          _v92 = _v89.delta_altitude
          _x = _v92.value
          buff.write(_get_struct_h().pack(_x))
          _v93 = val3.path_delta_time
          _x = _v93.value
          buff.write(_get_struct_H().pack(_x))
          _x = val3.path_delta_time_is_present
          buff.write(_get_struct_B().pack(_x))
      _x = self.detection_zones_to_specified_event_point_is_present
      buff.write(_get_struct_B().pack(_x))
      length = len(self.predicted_paths.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.predicted_paths.array:
        _v94 = val1.path_predicted
        length = len(_v94.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v94.array:
          _v95 = val3.delta_latitude
          _x = _v95.value
          buff.write(_get_struct_i().pack(_x))
          _v96 = val3.delta_longitude
          _x = _v96.value
          buff.write(_get_struct_i().pack(_x))
          _v97 = val3.horizontal_position_confidence
          _v98 = _v97.semi_major_confidence
          _x = _v98.value
          buff.write(_get_struct_H().pack(_x))
          _v99 = _v97.semi_minor_confidence
          _x = _v99.value
          buff.write(_get_struct_H().pack(_x))
          _v100 = _v97.semi_major_orientation
          _x = _v100.value
          buff.write(_get_struct_H().pack(_x))
          _x = val3.horizontal_position_confidence_is_present
          buff.write(_get_struct_B().pack(_x))
          _v101 = val3.delta_altitude
          _x = _v101.value
          buff.write(_get_struct_h().pack(_x))
          _v102 = val3.altitude_confidence
          _x = _v102.value
          buff.write(_get_struct_B().pack(_x))
          _v103 = val3.path_delta_time
          _x = _v103.choice
          buff.write(_get_struct_B().pack(_x))
          _v104 = _v103.delta_time_high_precision
          _x = _v104.value
          buff.write(_get_struct_B().pack(_x))
          _v105 = _v103.delta_time_big_range
          _x = _v105.value
          buff.write(_get_struct_B().pack(_x))
          _x = val3.path_delta_time_is_present
          buff.write(_get_struct_B().pack(_x))
          _v106 = val3.symmetric_area_offset
          _x = _v106.value
          buff.write(_get_struct_H().pack(_x))
          _x = val3.symmetric_area_offset_is_present
          buff.write(_get_struct_B().pack(_x))
          _v107 = val3.asymmetric_area_offset
          _x = _v107.value
          buff.write(_get_struct_H().pack(_x))
          _x = val3.asymmetric_area_offset_is_present
          buff.write(_get_struct_B().pack(_x))
        _v108 = val1.usage_indication
        _x = _v108.value
        buff.write(_get_struct_B().pack(_x))
        _v109 = val1.confidence_level
        _x = _v109.value
        buff.write(_get_struct_B().pack(_x))
      _x = self.predicted_paths_is_present
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.event_speed is None:
        self.event_speed = etsi_its_denm_ts_msgs.msg.Speed()
      if self.event_position_heading is None:
        self.event_position_heading = etsi_its_denm_ts_msgs.msg.Wgs84Angle()
      if self.detection_zones_to_event_position is None:
        self.detection_zones_to_event_position = etsi_its_denm_ts_msgs.msg.Traces()
      if self.road_type is None:
        self.road_type = etsi_its_denm_ts_msgs.msg.RoadType()
      if self.lane_positions is None:
        self.lane_positions = etsi_its_denm_ts_msgs.msg.GeneralizedLanePositions()
      if self.occupied_lanes is None:
        self.occupied_lanes = etsi_its_denm_ts_msgs.msg.OccupiedLanesWithConfidence()
      if self.linked_ivims is None:
        self.linked_ivims = etsi_its_denm_ts_msgs.msg.IvimReferences()
      if self.linked_mapems is None:
        self.linked_mapems = etsi_its_denm_ts_msgs.msg.MapReferences()
      if self.detection_zones_to_specified_event_point is None:
        self.detection_zones_to_specified_event_point = etsi_its_denm_ts_msgs.msg.TracesExtended()
      if self.predicted_paths is None:
        self.predicted_paths = etsi_its_denm_ts_msgs.msg.PathPredictedList()
      end = 0
      _x = self
      start = end
      end += 8
      (_x.event_speed.speed_value.value, _x.event_speed.speed_confidence.value, _x.event_speed_is_present, _x.event_position_heading.value.value, _x.event_position_heading.confidence.value, _x.event_position_heading_is_present,) = _get_struct_H2BH2B().unpack(str[start:end])
      self.event_speed_is_present = bool(self.event_speed_is_present)
      self.event_position_heading_is_present = bool(self.event_position_heading_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.detection_zones_to_event_position.array = []
      for i in range(0, length):
        val1 = etsi_its_denm_ts_msgs.msg.Path()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.array = []
        for i in range(0, length):
          val2 = etsi_its_denm_ts_msgs.msg.PathPoint()
          _v110 = val2.path_position
          _v111 = _v110.delta_latitude
          start = end
          end += 4
          (_v111.value,) = _get_struct_i().unpack(str[start:end])
          _v112 = _v110.delta_longitude
          start = end
          end += 4
          (_v112.value,) = _get_struct_i().unpack(str[start:end])
          _v113 = _v110.delta_altitude
          start = end
          end += 2
          (_v113.value,) = _get_struct_h().unpack(str[start:end])
          _v114 = val2.path_delta_time
          start = end
          end += 2
          (_v114.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val2.path_delta_time_is_present,) = _get_struct_B().unpack(str[start:end])
          val2.path_delta_time_is_present = bool(val2.path_delta_time_is_present)
          val1.array.append(val2)
        self.detection_zones_to_event_position.array.append(val1)
      _x = self
      start = end
      end += 2
      (_x.road_type.value, _x.road_type_is_present,) = _get_struct_2B().unpack(str[start:end])
      self.road_type_is_present = bool(self.road_type_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.lane_positions.array = []
      for i in range(0, length):
        val1 = etsi_its_denm_ts_msgs.msg.GeneralizedLanePosition()
        _v115 = val1.lane_position_based
        start = end
        end += 1
        (_v115.choice,) = _get_struct_B().unpack(str[start:end])
        _v116 = _v115.simplelane_position
        start = end
        end += 1
        (_v116.value,) = _get_struct_b().unpack(str[start:end])
        _v117 = _v115.simple_lane_type
        start = end
        end += 1
        (_v117.value,) = _get_struct_B().unpack(str[start:end])
        _v118 = _v115.detailedlane_position
        _v119 = _v118.transversal_position
        start = end
        end += 1
        (_v119.value,) = _get_struct_b().unpack(str[start:end])
        _v120 = _v118.lane_type
        start = end
        end += 1
        (_v120.value,) = _get_struct_B().unpack(str[start:end])
        _v121 = _v118.direction
        start = end
        end += 1
        (_v121.value,) = _get_struct_B().unpack(str[start:end])
        _v122 = _v115.lane_position_with_lateral_details
        _v123 = _v122.transversal_position
        start = end
        end += 1
        (_v123.value,) = _get_struct_b().unpack(str[start:end])
        _v124 = _v122.lane_type
        start = end
        end += 1
        (_v124.value,) = _get_struct_B().unpack(str[start:end])
        _v125 = _v122.direction
        start = end
        end += 1
        (_v125.value,) = _get_struct_B().unpack(str[start:end])
        _v126 = _v122.distance_to_left_border
        start = end
        end += 2
        (_v126.value,) = _get_struct_H().unpack(str[start:end])
        _v127 = _v122.distance_to_right_border
        start = end
        end += 2
        (_v127.value,) = _get_struct_H().unpack(str[start:end])
        _v128 = _v115.traffic_island_position
        _v129 = _v128.one_side
        _v130 = _v129.transversal_position
        start = end
        end += 1
        (_v130.value,) = _get_struct_b().unpack(str[start:end])
        _v131 = _v129.lane_type
        start = end
        end += 1
        (_v131.value,) = _get_struct_B().unpack(str[start:end])
        _v132 = _v129.direction
        start = end
        end += 1
        (_v132.value,) = _get_struct_B().unpack(str[start:end])
        _v133 = _v128.other_side
        _v134 = _v133.transversal_position
        start = end
        end += 1
        (_v134.value,) = _get_struct_b().unpack(str[start:end])
        _v135 = _v133.lane_type
        start = end
        end += 1
        (_v135.value,) = _get_struct_B().unpack(str[start:end])
        _v136 = _v133.direction
        start = end
        end += 1
        (_v136.value,) = _get_struct_B().unpack(str[start:end])
        _v137 = val1.map_based
        _v138 = _v137.map_reference
        start = end
        end += 1
        (_v138.choice,) = _get_struct_B().unpack(str[start:end])
        _v139 = _v138.roadsegment
        _v140 = _v139.region
        start = end
        end += 2
        (_v140.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v139.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v139.region_is_present = bool(_v139.region_is_present)
        _v141 = _v139.id
        start = end
        end += 2
        (_v141.value,) = _get_struct_H().unpack(str[start:end])
        _v142 = _v138.intersection
        _v143 = _v142.region
        start = end
        end += 2
        (_v143.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v142.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v142.region_is_present = bool(_v142.region_is_present)
        _v144 = _v142.id
        start = end
        end += 2
        (_v144.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v137.map_reference_is_present,) = _get_struct_B().unpack(str[start:end])
        _v137.map_reference_is_present = bool(_v137.map_reference_is_present)
        _v145 = _v137.lane_id
        start = end
        end += 1
        (_v145.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v137.lane_id_is_present,) = _get_struct_B().unpack(str[start:end])
        _v137.lane_id_is_present = bool(_v137.lane_id_is_present)
        _v146 = _v137.connection_id
        start = end
        end += 1
        (_v146.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v137.connection_id_is_present,) = _get_struct_B().unpack(str[start:end])
        _v137.connection_id_is_present = bool(_v137.connection_id_is_present)
        _v147 = _v137.longitudinal_lane_position
        _v148 = _v147.longitudinal_lane_position_value
        start = end
        end += 2
        (_v148.value,) = _get_struct_H().unpack(str[start:end])
        _v149 = _v147.longitudinal_lane_position_confidence
        start = end
        end += 2
        (_v149.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v137.longitudinal_lane_position_is_present,) = _get_struct_B().unpack(str[start:end])
        _v137.longitudinal_lane_position_is_present = bool(_v137.longitudinal_lane_position_is_present)
        start = end
        end += 1
        (val1.map_based_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.map_based_is_present = bool(val1.map_based_is_present)
        _v150 = val1.confidence
        _v151 = _v150.used_detection_information
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v151.value = str[start:end]
        start = end
        end += 1
        (_v151.bits_unused,) = _get_struct_B().unpack(str[start:end])
        _v152 = _v150.used_stored_information
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v152.value = str[start:end]
        start = end
        end += 1
        (_v152.bits_unused,) = _get_struct_B().unpack(str[start:end])
        _v153 = _v150.confidence_value
        start = end
        end += 1
        (_v153.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v150.confidence_value_is_present,) = _get_struct_B().unpack(str[start:end])
        _v150.confidence_value_is_present = bool(_v150.confidence_value_is_present)
        self.lane_positions.array.append(val1)
      start = end
      end += 1
      (self.lane_positions_is_present,) = _get_struct_B().unpack(str[start:end])
      self.lane_positions_is_present = bool(self.lane_positions_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.occupied_lanes.lane_position_based = []
      for i in range(0, length):
        val1 = etsi_its_denm_ts_msgs.msg.LanePositionOptions()
        start = end
        end += 1
        (val1.choice,) = _get_struct_B().unpack(str[start:end])
        _v154 = val1.simplelane_position
        start = end
        end += 1
        (_v154.value,) = _get_struct_b().unpack(str[start:end])
        _v155 = val1.simple_lane_type
        start = end
        end += 1
        (_v155.value,) = _get_struct_B().unpack(str[start:end])
        _v156 = val1.detailedlane_position
        _v157 = _v156.transversal_position
        start = end
        end += 1
        (_v157.value,) = _get_struct_b().unpack(str[start:end])
        _v158 = _v156.lane_type
        start = end
        end += 1
        (_v158.value,) = _get_struct_B().unpack(str[start:end])
        _v159 = _v156.direction
        start = end
        end += 1
        (_v159.value,) = _get_struct_B().unpack(str[start:end])
        _v160 = val1.lane_position_with_lateral_details
        _v161 = _v160.transversal_position
        start = end
        end += 1
        (_v161.value,) = _get_struct_b().unpack(str[start:end])
        _v162 = _v160.lane_type
        start = end
        end += 1
        (_v162.value,) = _get_struct_B().unpack(str[start:end])
        _v163 = _v160.direction
        start = end
        end += 1
        (_v163.value,) = _get_struct_B().unpack(str[start:end])
        _v164 = _v160.distance_to_left_border
        start = end
        end += 2
        (_v164.value,) = _get_struct_H().unpack(str[start:end])
        _v165 = _v160.distance_to_right_border
        start = end
        end += 2
        (_v165.value,) = _get_struct_H().unpack(str[start:end])
        _v166 = val1.traffic_island_position
        _v167 = _v166.one_side
        _v168 = _v167.transversal_position
        start = end
        end += 1
        (_v168.value,) = _get_struct_b().unpack(str[start:end])
        _v169 = _v167.lane_type
        start = end
        end += 1
        (_v169.value,) = _get_struct_B().unpack(str[start:end])
        _v170 = _v167.direction
        start = end
        end += 1
        (_v170.value,) = _get_struct_B().unpack(str[start:end])
        _v171 = _v166.other_side
        _v172 = _v171.transversal_position
        start = end
        end += 1
        (_v172.value,) = _get_struct_b().unpack(str[start:end])
        _v173 = _v171.lane_type
        start = end
        end += 1
        (_v173.value,) = _get_struct_B().unpack(str[start:end])
        _v174 = _v171.direction
        start = end
        end += 1
        (_v174.value,) = _get_struct_B().unpack(str[start:end])
        self.occupied_lanes.lane_position_based.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.occupied_lanes.map_based = []
      for i in range(0, length):
        val1 = etsi_its_denm_ts_msgs.msg.MapPosition()
        _v175 = val1.map_reference
        start = end
        end += 1
        (_v175.choice,) = _get_struct_B().unpack(str[start:end])
        _v176 = _v175.roadsegment
        _v177 = _v176.region
        start = end
        end += 2
        (_v177.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v176.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v176.region_is_present = bool(_v176.region_is_present)
        _v178 = _v176.id
        start = end
        end += 2
        (_v178.value,) = _get_struct_H().unpack(str[start:end])
        _v179 = _v175.intersection
        _v180 = _v179.region
        start = end
        end += 2
        (_v180.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v179.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v179.region_is_present = bool(_v179.region_is_present)
        _v181 = _v179.id
        start = end
        end += 2
        (_v181.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.map_reference_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.map_reference_is_present = bool(val1.map_reference_is_present)
        _v182 = val1.lane_id
        start = end
        end += 1
        (_v182.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.lane_id_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.lane_id_is_present = bool(val1.lane_id_is_present)
        _v183 = val1.connection_id
        start = end
        end += 1
        (_v183.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.connection_id_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.connection_id_is_present = bool(val1.connection_id_is_present)
        _v184 = val1.longitudinal_lane_position
        _v185 = _v184.longitudinal_lane_position_value
        start = end
        end += 2
        (_v185.value,) = _get_struct_H().unpack(str[start:end])
        _v186 = _v184.longitudinal_lane_position_confidence
        start = end
        end += 2
        (_v186.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.longitudinal_lane_position_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.longitudinal_lane_position_is_present = bool(val1.longitudinal_lane_position_is_present)
        self.occupied_lanes.map_based.append(val1)
      start = end
      end += 1
      (self.occupied_lanes.map_based_is_present,) = _get_struct_B().unpack(str[start:end])
      self.occupied_lanes.map_based_is_present = bool(self.occupied_lanes.map_based_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.occupied_lanes.confidence.used_detection_information.value = str[start:end]
      start = end
      end += 1
      (self.occupied_lanes.confidence.used_detection_information.bits_unused,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.occupied_lanes.confidence.used_stored_information.value = str[start:end]
      _x = self
      start = end
      end += 4
      (_x.occupied_lanes.confidence.used_stored_information.bits_unused, _x.occupied_lanes.confidence.confidence_value.value, _x.occupied_lanes.confidence.confidence_value_is_present, _x.occupied_lanes_is_present,) = _get_struct_4B().unpack(str[start:end])
      self.occupied_lanes.confidence.confidence_value_is_present = bool(self.occupied_lanes.confidence.confidence_value_is_present)
      self.occupied_lanes_is_present = bool(self.occupied_lanes_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.linked_ivims.array = []
      for i in range(0, length):
        val1 = etsi_its_denm_ts_msgs.msg.IvimReference()
        _v187 = val1.service_provider_id
        _v188 = _v187.country_code
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v188.value = str[start:end]
        start = end
        end += 1
        (_v188.bits_unused,) = _get_struct_B().unpack(str[start:end])
        _v189 = _v187.provider_identifier
        start = end
        end += 2
        (_v189.value,) = _get_struct_H().unpack(str[start:end])
        _v190 = val1.ivi_identification_number
        start = end
        end += 2
        (_v190.value,) = _get_struct_H().unpack(str[start:end])
        self.linked_ivims.array.append(val1)
      start = end
      end += 1
      (self.linked_ivims_is_present,) = _get_struct_B().unpack(str[start:end])
      self.linked_ivims_is_present = bool(self.linked_ivims_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.linked_mapems.array = []
      for i in range(0, length):
        val1 = etsi_its_denm_ts_msgs.msg.MapReference()
        start = end
        end += 1
        (val1.choice,) = _get_struct_B().unpack(str[start:end])
        _v191 = val1.roadsegment
        _v192 = _v191.region
        start = end
        end += 2
        (_v192.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v191.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v191.region_is_present = bool(_v191.region_is_present)
        _v193 = _v191.id
        start = end
        end += 2
        (_v193.value,) = _get_struct_H().unpack(str[start:end])
        _v194 = val1.intersection
        _v195 = _v194.region
        start = end
        end += 2
        (_v195.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v194.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v194.region_is_present = bool(_v194.region_is_present)
        _v196 = _v194.id
        start = end
        end += 2
        (_v196.value,) = _get_struct_H().unpack(str[start:end])
        self.linked_mapems.array.append(val1)
      start = end
      end += 1
      (self.linked_mapems_is_present,) = _get_struct_B().unpack(str[start:end])
      self.linked_mapems_is_present = bool(self.linked_mapems_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.detection_zones_to_specified_event_point.array = []
      for i in range(0, length):
        val1 = etsi_its_denm_ts_msgs.msg.PathExtended()
        start = end
        end += 1
        (val1.point_of_event_zone,) = _get_struct_B().unpack(str[start:end])
        _v197 = val1.path
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v197.array = []
        for i in range(0, length):
          val3 = etsi_its_denm_ts_msgs.msg.PathPoint()
          _v198 = val3.path_position
          _v199 = _v198.delta_latitude
          start = end
          end += 4
          (_v199.value,) = _get_struct_i().unpack(str[start:end])
          _v200 = _v198.delta_longitude
          start = end
          end += 4
          (_v200.value,) = _get_struct_i().unpack(str[start:end])
          _v201 = _v198.delta_altitude
          start = end
          end += 2
          (_v201.value,) = _get_struct_h().unpack(str[start:end])
          _v202 = val3.path_delta_time
          start = end
          end += 2
          (_v202.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val3.path_delta_time_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.path_delta_time_is_present = bool(val3.path_delta_time_is_present)
          _v197.array.append(val3)
        self.detection_zones_to_specified_event_point.array.append(val1)
      start = end
      end += 1
      (self.detection_zones_to_specified_event_point_is_present,) = _get_struct_B().unpack(str[start:end])
      self.detection_zones_to_specified_event_point_is_present = bool(self.detection_zones_to_specified_event_point_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.predicted_paths.array = []
      for i in range(0, length):
        val1 = etsi_its_denm_ts_msgs.msg.PathPredicted2()
        _v203 = val1.path_predicted
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v203.array = []
        for i in range(0, length):
          val3 = etsi_its_denm_ts_msgs.msg.PathPointPredicted()
          _v204 = val3.delta_latitude
          start = end
          end += 4
          (_v204.value,) = _get_struct_i().unpack(str[start:end])
          _v205 = val3.delta_longitude
          start = end
          end += 4
          (_v205.value,) = _get_struct_i().unpack(str[start:end])
          _v206 = val3.horizontal_position_confidence
          _v207 = _v206.semi_major_confidence
          start = end
          end += 2
          (_v207.value,) = _get_struct_H().unpack(str[start:end])
          _v208 = _v206.semi_minor_confidence
          start = end
          end += 2
          (_v208.value,) = _get_struct_H().unpack(str[start:end])
          _v209 = _v206.semi_major_orientation
          start = end
          end += 2
          (_v209.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val3.horizontal_position_confidence_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.horizontal_position_confidence_is_present = bool(val3.horizontal_position_confidence_is_present)
          _v210 = val3.delta_altitude
          start = end
          end += 2
          (_v210.value,) = _get_struct_h().unpack(str[start:end])
          _v211 = val3.altitude_confidence
          start = end
          end += 1
          (_v211.value,) = _get_struct_B().unpack(str[start:end])
          _v212 = val3.path_delta_time
          start = end
          end += 1
          (_v212.choice,) = _get_struct_B().unpack(str[start:end])
          _v213 = _v212.delta_time_high_precision
          start = end
          end += 1
          (_v213.value,) = _get_struct_B().unpack(str[start:end])
          _v214 = _v212.delta_time_big_range
          start = end
          end += 1
          (_v214.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val3.path_delta_time_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.path_delta_time_is_present = bool(val3.path_delta_time_is_present)
          _v215 = val3.symmetric_area_offset
          start = end
          end += 2
          (_v215.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val3.symmetric_area_offset_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.symmetric_area_offset_is_present = bool(val3.symmetric_area_offset_is_present)
          _v216 = val3.asymmetric_area_offset
          start = end
          end += 2
          (_v216.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val3.asymmetric_area_offset_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.asymmetric_area_offset_is_present = bool(val3.asymmetric_area_offset_is_present)
          _v203.array.append(val3)
        _v217 = val1.usage_indication
        start = end
        end += 1
        (_v217.value,) = _get_struct_B().unpack(str[start:end])
        _v218 = val1.confidence_level
        start = end
        end += 1
        (_v218.value,) = _get_struct_B().unpack(str[start:end])
        self.predicted_paths.array.append(val1)
      start = end
      end += 1
      (self.predicted_paths_is_present,) = _get_struct_B().unpack(str[start:end])
      self.predicted_paths_is_present = bool(self.predicted_paths_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_H2BH2B().pack(_x.event_speed.speed_value.value, _x.event_speed.speed_confidence.value, _x.event_speed_is_present, _x.event_position_heading.value.value, _x.event_position_heading.confidence.value, _x.event_position_heading_is_present))
      length = len(self.detection_zones_to_event_position.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.detection_zones_to_event_position.array:
        length = len(val1.array)
        buff.write(_struct_I.pack(length))
        for val2 in val1.array:
          _v219 = val2.path_position
          _v220 = _v219.delta_latitude
          _x = _v220.value
          buff.write(_get_struct_i().pack(_x))
          _v221 = _v219.delta_longitude
          _x = _v221.value
          buff.write(_get_struct_i().pack(_x))
          _v222 = _v219.delta_altitude
          _x = _v222.value
          buff.write(_get_struct_h().pack(_x))
          _v223 = val2.path_delta_time
          _x = _v223.value
          buff.write(_get_struct_H().pack(_x))
          _x = val2.path_delta_time_is_present
          buff.write(_get_struct_B().pack(_x))
      _x = self
      buff.write(_get_struct_2B().pack(_x.road_type.value, _x.road_type_is_present))
      length = len(self.lane_positions.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.lane_positions.array:
        _v224 = val1.lane_position_based
        _x = _v224.choice
        buff.write(_get_struct_B().pack(_x))
        _v225 = _v224.simplelane_position
        _x = _v225.value
        buff.write(_get_struct_b().pack(_x))
        _v226 = _v224.simple_lane_type
        _x = _v226.value
        buff.write(_get_struct_B().pack(_x))
        _v227 = _v224.detailedlane_position
        _v228 = _v227.transversal_position
        _x = _v228.value
        buff.write(_get_struct_b().pack(_x))
        _v229 = _v227.lane_type
        _x = _v229.value
        buff.write(_get_struct_B().pack(_x))
        _v230 = _v227.direction
        _x = _v230.value
        buff.write(_get_struct_B().pack(_x))
        _v231 = _v224.lane_position_with_lateral_details
        _v232 = _v231.transversal_position
        _x = _v232.value
        buff.write(_get_struct_b().pack(_x))
        _v233 = _v231.lane_type
        _x = _v233.value
        buff.write(_get_struct_B().pack(_x))
        _v234 = _v231.direction
        _x = _v234.value
        buff.write(_get_struct_B().pack(_x))
        _v235 = _v231.distance_to_left_border
        _x = _v235.value
        buff.write(_get_struct_H().pack(_x))
        _v236 = _v231.distance_to_right_border
        _x = _v236.value
        buff.write(_get_struct_H().pack(_x))
        _v237 = _v224.traffic_island_position
        _v238 = _v237.one_side
        _v239 = _v238.transversal_position
        _x = _v239.value
        buff.write(_get_struct_b().pack(_x))
        _v240 = _v238.lane_type
        _x = _v240.value
        buff.write(_get_struct_B().pack(_x))
        _v241 = _v238.direction
        _x = _v241.value
        buff.write(_get_struct_B().pack(_x))
        _v242 = _v237.other_side
        _v243 = _v242.transversal_position
        _x = _v243.value
        buff.write(_get_struct_b().pack(_x))
        _v244 = _v242.lane_type
        _x = _v244.value
        buff.write(_get_struct_B().pack(_x))
        _v245 = _v242.direction
        _x = _v245.value
        buff.write(_get_struct_B().pack(_x))
        _v246 = val1.map_based
        _v247 = _v246.map_reference
        _x = _v247.choice
        buff.write(_get_struct_B().pack(_x))
        _v248 = _v247.roadsegment
        _v249 = _v248.region
        _x = _v249.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v248.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v250 = _v248.id
        _x = _v250.value
        buff.write(_get_struct_H().pack(_x))
        _v251 = _v247.intersection
        _v252 = _v251.region
        _x = _v252.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v251.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v253 = _v251.id
        _x = _v253.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v246.map_reference_is_present
        buff.write(_get_struct_B().pack(_x))
        _v254 = _v246.lane_id
        _x = _v254.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v246.lane_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v255 = _v246.connection_id
        _x = _v255.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v246.connection_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v256 = _v246.longitudinal_lane_position
        _v257 = _v256.longitudinal_lane_position_value
        _x = _v257.value
        buff.write(_get_struct_H().pack(_x))
        _v258 = _v256.longitudinal_lane_position_confidence
        _x = _v258.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v246.longitudinal_lane_position_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = val1.map_based_is_present
        buff.write(_get_struct_B().pack(_x))
        _v259 = val1.confidence
        _v260 = _v259.used_detection_information
        _x = _v260.value
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v260.bits_unused
        buff.write(_get_struct_B().pack(_x))
        _v261 = _v259.used_stored_information
        _x = _v261.value
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v261.bits_unused
        buff.write(_get_struct_B().pack(_x))
        _v262 = _v259.confidence_value
        _x = _v262.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v259.confidence_value_is_present
        buff.write(_get_struct_B().pack(_x))
      _x = self.lane_positions_is_present
      buff.write(_get_struct_B().pack(_x))
      length = len(self.occupied_lanes.lane_position_based)
      buff.write(_struct_I.pack(length))
      for val1 in self.occupied_lanes.lane_position_based:
        _x = val1.choice
        buff.write(_get_struct_B().pack(_x))
        _v263 = val1.simplelane_position
        _x = _v263.value
        buff.write(_get_struct_b().pack(_x))
        _v264 = val1.simple_lane_type
        _x = _v264.value
        buff.write(_get_struct_B().pack(_x))
        _v265 = val1.detailedlane_position
        _v266 = _v265.transversal_position
        _x = _v266.value
        buff.write(_get_struct_b().pack(_x))
        _v267 = _v265.lane_type
        _x = _v267.value
        buff.write(_get_struct_B().pack(_x))
        _v268 = _v265.direction
        _x = _v268.value
        buff.write(_get_struct_B().pack(_x))
        _v269 = val1.lane_position_with_lateral_details
        _v270 = _v269.transversal_position
        _x = _v270.value
        buff.write(_get_struct_b().pack(_x))
        _v271 = _v269.lane_type
        _x = _v271.value
        buff.write(_get_struct_B().pack(_x))
        _v272 = _v269.direction
        _x = _v272.value
        buff.write(_get_struct_B().pack(_x))
        _v273 = _v269.distance_to_left_border
        _x = _v273.value
        buff.write(_get_struct_H().pack(_x))
        _v274 = _v269.distance_to_right_border
        _x = _v274.value
        buff.write(_get_struct_H().pack(_x))
        _v275 = val1.traffic_island_position
        _v276 = _v275.one_side
        _v277 = _v276.transversal_position
        _x = _v277.value
        buff.write(_get_struct_b().pack(_x))
        _v278 = _v276.lane_type
        _x = _v278.value
        buff.write(_get_struct_B().pack(_x))
        _v279 = _v276.direction
        _x = _v279.value
        buff.write(_get_struct_B().pack(_x))
        _v280 = _v275.other_side
        _v281 = _v280.transversal_position
        _x = _v281.value
        buff.write(_get_struct_b().pack(_x))
        _v282 = _v280.lane_type
        _x = _v282.value
        buff.write(_get_struct_B().pack(_x))
        _v283 = _v280.direction
        _x = _v283.value
        buff.write(_get_struct_B().pack(_x))
      length = len(self.occupied_lanes.map_based)
      buff.write(_struct_I.pack(length))
      for val1 in self.occupied_lanes.map_based:
        _v284 = val1.map_reference
        _x = _v284.choice
        buff.write(_get_struct_B().pack(_x))
        _v285 = _v284.roadsegment
        _v286 = _v285.region
        _x = _v286.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v285.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v287 = _v285.id
        _x = _v287.value
        buff.write(_get_struct_H().pack(_x))
        _v288 = _v284.intersection
        _v289 = _v288.region
        _x = _v289.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v288.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v290 = _v288.id
        _x = _v290.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.map_reference_is_present
        buff.write(_get_struct_B().pack(_x))
        _v291 = val1.lane_id
        _x = _v291.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.lane_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v292 = val1.connection_id
        _x = _v292.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.connection_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v293 = val1.longitudinal_lane_position
        _v294 = _v293.longitudinal_lane_position_value
        _x = _v294.value
        buff.write(_get_struct_H().pack(_x))
        _v295 = _v293.longitudinal_lane_position_confidence
        _x = _v295.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.longitudinal_lane_position_is_present
        buff.write(_get_struct_B().pack(_x))
      _x = self.occupied_lanes.map_based_is_present
      buff.write(_get_struct_B().pack(_x))
      _x = self.occupied_lanes.confidence.used_detection_information.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.occupied_lanes.confidence.used_detection_information.bits_unused
      buff.write(_get_struct_B().pack(_x))
      _x = self.occupied_lanes.confidence.used_stored_information.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_4B().pack(_x.occupied_lanes.confidence.used_stored_information.bits_unused, _x.occupied_lanes.confidence.confidence_value.value, _x.occupied_lanes.confidence.confidence_value_is_present, _x.occupied_lanes_is_present))
      length = len(self.linked_ivims.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.linked_ivims.array:
        _v296 = val1.service_provider_id
        _v297 = _v296.country_code
        _x = _v297.value
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v297.bits_unused
        buff.write(_get_struct_B().pack(_x))
        _v298 = _v296.provider_identifier
        _x = _v298.value
        buff.write(_get_struct_H().pack(_x))
        _v299 = val1.ivi_identification_number
        _x = _v299.value
        buff.write(_get_struct_H().pack(_x))
      _x = self.linked_ivims_is_present
      buff.write(_get_struct_B().pack(_x))
      length = len(self.linked_mapems.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.linked_mapems.array:
        _x = val1.choice
        buff.write(_get_struct_B().pack(_x))
        _v300 = val1.roadsegment
        _v301 = _v300.region
        _x = _v301.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v300.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v302 = _v300.id
        _x = _v302.value
        buff.write(_get_struct_H().pack(_x))
        _v303 = val1.intersection
        _v304 = _v303.region
        _x = _v304.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v303.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v305 = _v303.id
        _x = _v305.value
        buff.write(_get_struct_H().pack(_x))
      _x = self.linked_mapems_is_present
      buff.write(_get_struct_B().pack(_x))
      length = len(self.detection_zones_to_specified_event_point.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.detection_zones_to_specified_event_point.array:
        _x = val1.point_of_event_zone
        buff.write(_get_struct_B().pack(_x))
        _v306 = val1.path
        length = len(_v306.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v306.array:
          _v307 = val3.path_position
          _v308 = _v307.delta_latitude
          _x = _v308.value
          buff.write(_get_struct_i().pack(_x))
          _v309 = _v307.delta_longitude
          _x = _v309.value
          buff.write(_get_struct_i().pack(_x))
          _v310 = _v307.delta_altitude
          _x = _v310.value
          buff.write(_get_struct_h().pack(_x))
          _v311 = val3.path_delta_time
          _x = _v311.value
          buff.write(_get_struct_H().pack(_x))
          _x = val3.path_delta_time_is_present
          buff.write(_get_struct_B().pack(_x))
      _x = self.detection_zones_to_specified_event_point_is_present
      buff.write(_get_struct_B().pack(_x))
      length = len(self.predicted_paths.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.predicted_paths.array:
        _v312 = val1.path_predicted
        length = len(_v312.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v312.array:
          _v313 = val3.delta_latitude
          _x = _v313.value
          buff.write(_get_struct_i().pack(_x))
          _v314 = val3.delta_longitude
          _x = _v314.value
          buff.write(_get_struct_i().pack(_x))
          _v315 = val3.horizontal_position_confidence
          _v316 = _v315.semi_major_confidence
          _x = _v316.value
          buff.write(_get_struct_H().pack(_x))
          _v317 = _v315.semi_minor_confidence
          _x = _v317.value
          buff.write(_get_struct_H().pack(_x))
          _v318 = _v315.semi_major_orientation
          _x = _v318.value
          buff.write(_get_struct_H().pack(_x))
          _x = val3.horizontal_position_confidence_is_present
          buff.write(_get_struct_B().pack(_x))
          _v319 = val3.delta_altitude
          _x = _v319.value
          buff.write(_get_struct_h().pack(_x))
          _v320 = val3.altitude_confidence
          _x = _v320.value
          buff.write(_get_struct_B().pack(_x))
          _v321 = val3.path_delta_time
          _x = _v321.choice
          buff.write(_get_struct_B().pack(_x))
          _v322 = _v321.delta_time_high_precision
          _x = _v322.value
          buff.write(_get_struct_B().pack(_x))
          _v323 = _v321.delta_time_big_range
          _x = _v323.value
          buff.write(_get_struct_B().pack(_x))
          _x = val3.path_delta_time_is_present
          buff.write(_get_struct_B().pack(_x))
          _v324 = val3.symmetric_area_offset
          _x = _v324.value
          buff.write(_get_struct_H().pack(_x))
          _x = val3.symmetric_area_offset_is_present
          buff.write(_get_struct_B().pack(_x))
          _v325 = val3.asymmetric_area_offset
          _x = _v325.value
          buff.write(_get_struct_H().pack(_x))
          _x = val3.asymmetric_area_offset_is_present
          buff.write(_get_struct_B().pack(_x))
        _v326 = val1.usage_indication
        _x = _v326.value
        buff.write(_get_struct_B().pack(_x))
        _v327 = val1.confidence_level
        _x = _v327.value
        buff.write(_get_struct_B().pack(_x))
      _x = self.predicted_paths_is_present
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.event_speed is None:
        self.event_speed = etsi_its_denm_ts_msgs.msg.Speed()
      if self.event_position_heading is None:
        self.event_position_heading = etsi_its_denm_ts_msgs.msg.Wgs84Angle()
      if self.detection_zones_to_event_position is None:
        self.detection_zones_to_event_position = etsi_its_denm_ts_msgs.msg.Traces()
      if self.road_type is None:
        self.road_type = etsi_its_denm_ts_msgs.msg.RoadType()
      if self.lane_positions is None:
        self.lane_positions = etsi_its_denm_ts_msgs.msg.GeneralizedLanePositions()
      if self.occupied_lanes is None:
        self.occupied_lanes = etsi_its_denm_ts_msgs.msg.OccupiedLanesWithConfidence()
      if self.linked_ivims is None:
        self.linked_ivims = etsi_its_denm_ts_msgs.msg.IvimReferences()
      if self.linked_mapems is None:
        self.linked_mapems = etsi_its_denm_ts_msgs.msg.MapReferences()
      if self.detection_zones_to_specified_event_point is None:
        self.detection_zones_to_specified_event_point = etsi_its_denm_ts_msgs.msg.TracesExtended()
      if self.predicted_paths is None:
        self.predicted_paths = etsi_its_denm_ts_msgs.msg.PathPredictedList()
      end = 0
      _x = self
      start = end
      end += 8
      (_x.event_speed.speed_value.value, _x.event_speed.speed_confidence.value, _x.event_speed_is_present, _x.event_position_heading.value.value, _x.event_position_heading.confidence.value, _x.event_position_heading_is_present,) = _get_struct_H2BH2B().unpack(str[start:end])
      self.event_speed_is_present = bool(self.event_speed_is_present)
      self.event_position_heading_is_present = bool(self.event_position_heading_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.detection_zones_to_event_position.array = []
      for i in range(0, length):
        val1 = etsi_its_denm_ts_msgs.msg.Path()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.array = []
        for i in range(0, length):
          val2 = etsi_its_denm_ts_msgs.msg.PathPoint()
          _v328 = val2.path_position
          _v329 = _v328.delta_latitude
          start = end
          end += 4
          (_v329.value,) = _get_struct_i().unpack(str[start:end])
          _v330 = _v328.delta_longitude
          start = end
          end += 4
          (_v330.value,) = _get_struct_i().unpack(str[start:end])
          _v331 = _v328.delta_altitude
          start = end
          end += 2
          (_v331.value,) = _get_struct_h().unpack(str[start:end])
          _v332 = val2.path_delta_time
          start = end
          end += 2
          (_v332.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val2.path_delta_time_is_present,) = _get_struct_B().unpack(str[start:end])
          val2.path_delta_time_is_present = bool(val2.path_delta_time_is_present)
          val1.array.append(val2)
        self.detection_zones_to_event_position.array.append(val1)
      _x = self
      start = end
      end += 2
      (_x.road_type.value, _x.road_type_is_present,) = _get_struct_2B().unpack(str[start:end])
      self.road_type_is_present = bool(self.road_type_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.lane_positions.array = []
      for i in range(0, length):
        val1 = etsi_its_denm_ts_msgs.msg.GeneralizedLanePosition()
        _v333 = val1.lane_position_based
        start = end
        end += 1
        (_v333.choice,) = _get_struct_B().unpack(str[start:end])
        _v334 = _v333.simplelane_position
        start = end
        end += 1
        (_v334.value,) = _get_struct_b().unpack(str[start:end])
        _v335 = _v333.simple_lane_type
        start = end
        end += 1
        (_v335.value,) = _get_struct_B().unpack(str[start:end])
        _v336 = _v333.detailedlane_position
        _v337 = _v336.transversal_position
        start = end
        end += 1
        (_v337.value,) = _get_struct_b().unpack(str[start:end])
        _v338 = _v336.lane_type
        start = end
        end += 1
        (_v338.value,) = _get_struct_B().unpack(str[start:end])
        _v339 = _v336.direction
        start = end
        end += 1
        (_v339.value,) = _get_struct_B().unpack(str[start:end])
        _v340 = _v333.lane_position_with_lateral_details
        _v341 = _v340.transversal_position
        start = end
        end += 1
        (_v341.value,) = _get_struct_b().unpack(str[start:end])
        _v342 = _v340.lane_type
        start = end
        end += 1
        (_v342.value,) = _get_struct_B().unpack(str[start:end])
        _v343 = _v340.direction
        start = end
        end += 1
        (_v343.value,) = _get_struct_B().unpack(str[start:end])
        _v344 = _v340.distance_to_left_border
        start = end
        end += 2
        (_v344.value,) = _get_struct_H().unpack(str[start:end])
        _v345 = _v340.distance_to_right_border
        start = end
        end += 2
        (_v345.value,) = _get_struct_H().unpack(str[start:end])
        _v346 = _v333.traffic_island_position
        _v347 = _v346.one_side
        _v348 = _v347.transversal_position
        start = end
        end += 1
        (_v348.value,) = _get_struct_b().unpack(str[start:end])
        _v349 = _v347.lane_type
        start = end
        end += 1
        (_v349.value,) = _get_struct_B().unpack(str[start:end])
        _v350 = _v347.direction
        start = end
        end += 1
        (_v350.value,) = _get_struct_B().unpack(str[start:end])
        _v351 = _v346.other_side
        _v352 = _v351.transversal_position
        start = end
        end += 1
        (_v352.value,) = _get_struct_b().unpack(str[start:end])
        _v353 = _v351.lane_type
        start = end
        end += 1
        (_v353.value,) = _get_struct_B().unpack(str[start:end])
        _v354 = _v351.direction
        start = end
        end += 1
        (_v354.value,) = _get_struct_B().unpack(str[start:end])
        _v355 = val1.map_based
        _v356 = _v355.map_reference
        start = end
        end += 1
        (_v356.choice,) = _get_struct_B().unpack(str[start:end])
        _v357 = _v356.roadsegment
        _v358 = _v357.region
        start = end
        end += 2
        (_v358.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v357.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v357.region_is_present = bool(_v357.region_is_present)
        _v359 = _v357.id
        start = end
        end += 2
        (_v359.value,) = _get_struct_H().unpack(str[start:end])
        _v360 = _v356.intersection
        _v361 = _v360.region
        start = end
        end += 2
        (_v361.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v360.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v360.region_is_present = bool(_v360.region_is_present)
        _v362 = _v360.id
        start = end
        end += 2
        (_v362.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v355.map_reference_is_present,) = _get_struct_B().unpack(str[start:end])
        _v355.map_reference_is_present = bool(_v355.map_reference_is_present)
        _v363 = _v355.lane_id
        start = end
        end += 1
        (_v363.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v355.lane_id_is_present,) = _get_struct_B().unpack(str[start:end])
        _v355.lane_id_is_present = bool(_v355.lane_id_is_present)
        _v364 = _v355.connection_id
        start = end
        end += 1
        (_v364.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v355.connection_id_is_present,) = _get_struct_B().unpack(str[start:end])
        _v355.connection_id_is_present = bool(_v355.connection_id_is_present)
        _v365 = _v355.longitudinal_lane_position
        _v366 = _v365.longitudinal_lane_position_value
        start = end
        end += 2
        (_v366.value,) = _get_struct_H().unpack(str[start:end])
        _v367 = _v365.longitudinal_lane_position_confidence
        start = end
        end += 2
        (_v367.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v355.longitudinal_lane_position_is_present,) = _get_struct_B().unpack(str[start:end])
        _v355.longitudinal_lane_position_is_present = bool(_v355.longitudinal_lane_position_is_present)
        start = end
        end += 1
        (val1.map_based_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.map_based_is_present = bool(val1.map_based_is_present)
        _v368 = val1.confidence
        _v369 = _v368.used_detection_information
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v369.value = str[start:end]
        start = end
        end += 1
        (_v369.bits_unused,) = _get_struct_B().unpack(str[start:end])
        _v370 = _v368.used_stored_information
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v370.value = str[start:end]
        start = end
        end += 1
        (_v370.bits_unused,) = _get_struct_B().unpack(str[start:end])
        _v371 = _v368.confidence_value
        start = end
        end += 1
        (_v371.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v368.confidence_value_is_present,) = _get_struct_B().unpack(str[start:end])
        _v368.confidence_value_is_present = bool(_v368.confidence_value_is_present)
        self.lane_positions.array.append(val1)
      start = end
      end += 1
      (self.lane_positions_is_present,) = _get_struct_B().unpack(str[start:end])
      self.lane_positions_is_present = bool(self.lane_positions_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.occupied_lanes.lane_position_based = []
      for i in range(0, length):
        val1 = etsi_its_denm_ts_msgs.msg.LanePositionOptions()
        start = end
        end += 1
        (val1.choice,) = _get_struct_B().unpack(str[start:end])
        _v372 = val1.simplelane_position
        start = end
        end += 1
        (_v372.value,) = _get_struct_b().unpack(str[start:end])
        _v373 = val1.simple_lane_type
        start = end
        end += 1
        (_v373.value,) = _get_struct_B().unpack(str[start:end])
        _v374 = val1.detailedlane_position
        _v375 = _v374.transversal_position
        start = end
        end += 1
        (_v375.value,) = _get_struct_b().unpack(str[start:end])
        _v376 = _v374.lane_type
        start = end
        end += 1
        (_v376.value,) = _get_struct_B().unpack(str[start:end])
        _v377 = _v374.direction
        start = end
        end += 1
        (_v377.value,) = _get_struct_B().unpack(str[start:end])
        _v378 = val1.lane_position_with_lateral_details
        _v379 = _v378.transversal_position
        start = end
        end += 1
        (_v379.value,) = _get_struct_b().unpack(str[start:end])
        _v380 = _v378.lane_type
        start = end
        end += 1
        (_v380.value,) = _get_struct_B().unpack(str[start:end])
        _v381 = _v378.direction
        start = end
        end += 1
        (_v381.value,) = _get_struct_B().unpack(str[start:end])
        _v382 = _v378.distance_to_left_border
        start = end
        end += 2
        (_v382.value,) = _get_struct_H().unpack(str[start:end])
        _v383 = _v378.distance_to_right_border
        start = end
        end += 2
        (_v383.value,) = _get_struct_H().unpack(str[start:end])
        _v384 = val1.traffic_island_position
        _v385 = _v384.one_side
        _v386 = _v385.transversal_position
        start = end
        end += 1
        (_v386.value,) = _get_struct_b().unpack(str[start:end])
        _v387 = _v385.lane_type
        start = end
        end += 1
        (_v387.value,) = _get_struct_B().unpack(str[start:end])
        _v388 = _v385.direction
        start = end
        end += 1
        (_v388.value,) = _get_struct_B().unpack(str[start:end])
        _v389 = _v384.other_side
        _v390 = _v389.transversal_position
        start = end
        end += 1
        (_v390.value,) = _get_struct_b().unpack(str[start:end])
        _v391 = _v389.lane_type
        start = end
        end += 1
        (_v391.value,) = _get_struct_B().unpack(str[start:end])
        _v392 = _v389.direction
        start = end
        end += 1
        (_v392.value,) = _get_struct_B().unpack(str[start:end])
        self.occupied_lanes.lane_position_based.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.occupied_lanes.map_based = []
      for i in range(0, length):
        val1 = etsi_its_denm_ts_msgs.msg.MapPosition()
        _v393 = val1.map_reference
        start = end
        end += 1
        (_v393.choice,) = _get_struct_B().unpack(str[start:end])
        _v394 = _v393.roadsegment
        _v395 = _v394.region
        start = end
        end += 2
        (_v395.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v394.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v394.region_is_present = bool(_v394.region_is_present)
        _v396 = _v394.id
        start = end
        end += 2
        (_v396.value,) = _get_struct_H().unpack(str[start:end])
        _v397 = _v393.intersection
        _v398 = _v397.region
        start = end
        end += 2
        (_v398.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v397.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v397.region_is_present = bool(_v397.region_is_present)
        _v399 = _v397.id
        start = end
        end += 2
        (_v399.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.map_reference_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.map_reference_is_present = bool(val1.map_reference_is_present)
        _v400 = val1.lane_id
        start = end
        end += 1
        (_v400.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.lane_id_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.lane_id_is_present = bool(val1.lane_id_is_present)
        _v401 = val1.connection_id
        start = end
        end += 1
        (_v401.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.connection_id_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.connection_id_is_present = bool(val1.connection_id_is_present)
        _v402 = val1.longitudinal_lane_position
        _v403 = _v402.longitudinal_lane_position_value
        start = end
        end += 2
        (_v403.value,) = _get_struct_H().unpack(str[start:end])
        _v404 = _v402.longitudinal_lane_position_confidence
        start = end
        end += 2
        (_v404.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.longitudinal_lane_position_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.longitudinal_lane_position_is_present = bool(val1.longitudinal_lane_position_is_present)
        self.occupied_lanes.map_based.append(val1)
      start = end
      end += 1
      (self.occupied_lanes.map_based_is_present,) = _get_struct_B().unpack(str[start:end])
      self.occupied_lanes.map_based_is_present = bool(self.occupied_lanes.map_based_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.occupied_lanes.confidence.used_detection_information.value = str[start:end]
      start = end
      end += 1
      (self.occupied_lanes.confidence.used_detection_information.bits_unused,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.occupied_lanes.confidence.used_stored_information.value = str[start:end]
      _x = self
      start = end
      end += 4
      (_x.occupied_lanes.confidence.used_stored_information.bits_unused, _x.occupied_lanes.confidence.confidence_value.value, _x.occupied_lanes.confidence.confidence_value_is_present, _x.occupied_lanes_is_present,) = _get_struct_4B().unpack(str[start:end])
      self.occupied_lanes.confidence.confidence_value_is_present = bool(self.occupied_lanes.confidence.confidence_value_is_present)
      self.occupied_lanes_is_present = bool(self.occupied_lanes_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.linked_ivims.array = []
      for i in range(0, length):
        val1 = etsi_its_denm_ts_msgs.msg.IvimReference()
        _v405 = val1.service_provider_id
        _v406 = _v405.country_code
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v406.value = str[start:end]
        start = end
        end += 1
        (_v406.bits_unused,) = _get_struct_B().unpack(str[start:end])
        _v407 = _v405.provider_identifier
        start = end
        end += 2
        (_v407.value,) = _get_struct_H().unpack(str[start:end])
        _v408 = val1.ivi_identification_number
        start = end
        end += 2
        (_v408.value,) = _get_struct_H().unpack(str[start:end])
        self.linked_ivims.array.append(val1)
      start = end
      end += 1
      (self.linked_ivims_is_present,) = _get_struct_B().unpack(str[start:end])
      self.linked_ivims_is_present = bool(self.linked_ivims_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.linked_mapems.array = []
      for i in range(0, length):
        val1 = etsi_its_denm_ts_msgs.msg.MapReference()
        start = end
        end += 1
        (val1.choice,) = _get_struct_B().unpack(str[start:end])
        _v409 = val1.roadsegment
        _v410 = _v409.region
        start = end
        end += 2
        (_v410.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v409.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v409.region_is_present = bool(_v409.region_is_present)
        _v411 = _v409.id
        start = end
        end += 2
        (_v411.value,) = _get_struct_H().unpack(str[start:end])
        _v412 = val1.intersection
        _v413 = _v412.region
        start = end
        end += 2
        (_v413.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v412.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v412.region_is_present = bool(_v412.region_is_present)
        _v414 = _v412.id
        start = end
        end += 2
        (_v414.value,) = _get_struct_H().unpack(str[start:end])
        self.linked_mapems.array.append(val1)
      start = end
      end += 1
      (self.linked_mapems_is_present,) = _get_struct_B().unpack(str[start:end])
      self.linked_mapems_is_present = bool(self.linked_mapems_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.detection_zones_to_specified_event_point.array = []
      for i in range(0, length):
        val1 = etsi_its_denm_ts_msgs.msg.PathExtended()
        start = end
        end += 1
        (val1.point_of_event_zone,) = _get_struct_B().unpack(str[start:end])
        _v415 = val1.path
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v415.array = []
        for i in range(0, length):
          val3 = etsi_its_denm_ts_msgs.msg.PathPoint()
          _v416 = val3.path_position
          _v417 = _v416.delta_latitude
          start = end
          end += 4
          (_v417.value,) = _get_struct_i().unpack(str[start:end])
          _v418 = _v416.delta_longitude
          start = end
          end += 4
          (_v418.value,) = _get_struct_i().unpack(str[start:end])
          _v419 = _v416.delta_altitude
          start = end
          end += 2
          (_v419.value,) = _get_struct_h().unpack(str[start:end])
          _v420 = val3.path_delta_time
          start = end
          end += 2
          (_v420.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val3.path_delta_time_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.path_delta_time_is_present = bool(val3.path_delta_time_is_present)
          _v415.array.append(val3)
        self.detection_zones_to_specified_event_point.array.append(val1)
      start = end
      end += 1
      (self.detection_zones_to_specified_event_point_is_present,) = _get_struct_B().unpack(str[start:end])
      self.detection_zones_to_specified_event_point_is_present = bool(self.detection_zones_to_specified_event_point_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.predicted_paths.array = []
      for i in range(0, length):
        val1 = etsi_its_denm_ts_msgs.msg.PathPredicted2()
        _v421 = val1.path_predicted
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v421.array = []
        for i in range(0, length):
          val3 = etsi_its_denm_ts_msgs.msg.PathPointPredicted()
          _v422 = val3.delta_latitude
          start = end
          end += 4
          (_v422.value,) = _get_struct_i().unpack(str[start:end])
          _v423 = val3.delta_longitude
          start = end
          end += 4
          (_v423.value,) = _get_struct_i().unpack(str[start:end])
          _v424 = val3.horizontal_position_confidence
          _v425 = _v424.semi_major_confidence
          start = end
          end += 2
          (_v425.value,) = _get_struct_H().unpack(str[start:end])
          _v426 = _v424.semi_minor_confidence
          start = end
          end += 2
          (_v426.value,) = _get_struct_H().unpack(str[start:end])
          _v427 = _v424.semi_major_orientation
          start = end
          end += 2
          (_v427.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val3.horizontal_position_confidence_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.horizontal_position_confidence_is_present = bool(val3.horizontal_position_confidence_is_present)
          _v428 = val3.delta_altitude
          start = end
          end += 2
          (_v428.value,) = _get_struct_h().unpack(str[start:end])
          _v429 = val3.altitude_confidence
          start = end
          end += 1
          (_v429.value,) = _get_struct_B().unpack(str[start:end])
          _v430 = val3.path_delta_time
          start = end
          end += 1
          (_v430.choice,) = _get_struct_B().unpack(str[start:end])
          _v431 = _v430.delta_time_high_precision
          start = end
          end += 1
          (_v431.value,) = _get_struct_B().unpack(str[start:end])
          _v432 = _v430.delta_time_big_range
          start = end
          end += 1
          (_v432.value,) = _get_struct_B().unpack(str[start:end])
          start = end
          end += 1
          (val3.path_delta_time_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.path_delta_time_is_present = bool(val3.path_delta_time_is_present)
          _v433 = val3.symmetric_area_offset
          start = end
          end += 2
          (_v433.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val3.symmetric_area_offset_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.symmetric_area_offset_is_present = bool(val3.symmetric_area_offset_is_present)
          _v434 = val3.asymmetric_area_offset
          start = end
          end += 2
          (_v434.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val3.asymmetric_area_offset_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.asymmetric_area_offset_is_present = bool(val3.asymmetric_area_offset_is_present)
          _v421.array.append(val3)
        _v435 = val1.usage_indication
        start = end
        end += 1
        (_v435.value,) = _get_struct_B().unpack(str[start:end])
        _v436 = val1.confidence_level
        start = end
        end += 1
        (_v436.value,) = _get_struct_B().unpack(str[start:end])
        self.predicted_paths.array.append(val1)
      start = end
      end += 1
      (self.predicted_paths_is_present,) = _get_struct_B().unpack(str[start:end])
      self.predicted_paths_is_present = bool(self.predicted_paths_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
_struct_4B = None
def _get_struct_4B():
    global _struct_4B
    if _struct_4B is None:
        _struct_4B = struct.Struct("<4B")
    return _struct_4B
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_H = None
def _get_struct_H():
    global _struct_H
    if _struct_H is None:
        _struct_H = struct.Struct("<H")
    return _struct_H
_struct_H2BH2B = None
def _get_struct_H2BH2B():
    global _struct_H2BH2B
    if _struct_H2BH2B is None:
        _struct_H2BH2B = struct.Struct("<H2BH2B")
    return _struct_H2BH2B
_struct_b = None
def _get_struct_b():
    global _struct_b
    if _struct_b is None:
        _struct_b = struct.Struct("<b")
    return _struct_b
_struct_h = None
def _get_struct_h():
    global _struct_h
    if _struct_h is None:
        _struct_h = struct.Struct("<h")
    return _struct_h
_struct_i = None
def _get_struct_i():
    global _struct_i
    if _struct_i is None:
        _struct_i = struct.Struct("<i")
    return _struct_i
